/// <reference path="./custom.d.ts" />
// tslint:disable
/**
 * AirNav On Demand API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2.3.16
 * 
 *
 * NOTE: This file is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the file manually.
 */

import * as url from "url";
import * as isomorphicFetch from "isomorphic-fetch";
import { Configuration } from "./configuration";

const BASE_PATH = "https://api.airnavradar.com/v2".replace(/\/+$/, "");

/**
 *
 * @export
 */
export const COLLECTION_FORMATS = {
    csv: ",",
    ssv: " ",
    tsv: "\t",
    pipes: "|",
};

/**
 *
 * @export
 * @interface FetchAPI
 */
export interface FetchAPI {
    (url: string, init?: any): Promise<Response>;
}

/**
 *
 * @export
 * @interface FetchArgs
 */
export interface FetchArgs {
    url: string;
    options: any;
}

/**
 *
 * @export
 * @class BaseAPI
 */
export class BaseAPI {
    protected configuration: Configuration;

    constructor(configuration?: Configuration, protected basePath: string = BASE_PATH, protected fetch: FetchAPI = isomorphicFetch) {
        if (configuration) {
            this.configuration = configuration;
            this.basePath = configuration.basePath || this.basePath;
        }
    }
};

/**
 *
 * @export
 * @class RequiredError
 * @extends {Error}
 */
export class RequiredError extends Error {
    name: "RequiredError"
    constructor(public field: string, msg?: string) {
        super(msg);
    }
}

/**
 * 
 * @export
 * @interface AirlineStatisticsResponse
 */
export interface AirlineStatisticsResponse {
    /**
     * 
     * @type {number}
     * @memberof AirlineStatisticsResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof AirlineStatisticsResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof AirlineStatisticsResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof AirlineStatisticsResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof AirlineStatisticsResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {Array<ApiAirlineStatistics>}
     * @memberof AirlineStatisticsResponse
     */
    airlineStatistics?: Array<ApiAirlineStatistics>;
}
/**
 * 
 * @export
 * @interface AirportsStatisticsResponse
 */
export interface AirportsStatisticsResponse {
    /**
     * 
     * @type {number}
     * @memberof AirportsStatisticsResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof AirportsStatisticsResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof AirportsStatisticsResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof AirportsStatisticsResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof AirportsStatisticsResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {Array<ApiAirportStatistics>}
     * @memberof AirportsStatisticsResponse
     */
    statistics?: Array<ApiAirportStatistics>;
}
/**
 * 
 * @export
 * @interface ApiAircraft
 */
export interface ApiAircraft {
    /**
     * 
     * @type {string}
     * @memberof ApiAircraft
     */
    modeS?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiAircraft
     */
    registration?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiAircraft
     */
    typeIcao?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiAircraft
     */
    typeIata?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiAircraft
     */
    typeDescription?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiAircraft
     */
    classDescription?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiAircraft
     */
    companyIcao?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiAircraft
     */
    companyName?: string;
    /**
     * 
     * @type {Date}
     * @memberof ApiAircraft
     */
    firstFlight?: Date;
    /**
     * 
     * @type {string}
     * @memberof ApiAircraft
     */
    serialNumber?: string;
    /**
     * 
     * @type {Array<string>}
     * @memberof ApiAircraft
     */
    photos?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof ApiAircraft
     */
    thumbnails?: Array<string>;
    /**
     * 
     * @type {Array<ApiAircraftStatistic>}
     * @memberof ApiAircraft
     */
    aircraftStatitics?: Array<ApiAircraftStatistic>;
    /**
     * 
     * @type {boolean}
     * @memberof ApiAircraft
     */
    decommissioned?: boolean;
}
/**
 * 
 * @export
 * @interface ApiAircraftStatistic
 */
export interface ApiAircraftStatistic {
    /**
     * 
     * @type {number}
     * @memberof ApiAircraftStatistic
     */
    year?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiAircraftStatistic
     */
    month?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiAircraftStatistic
     */
    distance?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiAircraftStatistic
     */
    duration?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiAircraftStatistic
     */
    durationRunway?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiAircraftStatistic
     */
    durationRunwayAccuracy?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiAircraftStatistic
     */
    activeDays?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiAircraftStatistic
     */
    flights?: number;
    /**
     * 
     * @type {Array<ApiStatisticAirport>}
     * @memberof ApiAircraftStatistic
     */
    airportMovements?: Array<ApiStatisticAirport>;
}
/**
 * 
 * @export
 * @interface ApiAircraftTypeUtilization
 */
export interface ApiAircraftTypeUtilization {
    /**
     * 
     * @type {string}
     * @memberof ApiAircraftTypeUtilization
     */
    aircraftType?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiAircraftTypeUtilization
     */
    totalAircraft?: number;
    /**
     * 
     * @type {Array<ApiAircraftTypeUtilizationPeriod>}
     * @memberof ApiAircraftTypeUtilization
     */
    apiAircraftUtilizationPeriods?: Array<ApiAircraftTypeUtilizationPeriod>;
}
/**
 * 
 * @export
 * @interface ApiAircraftTypeUtilizationPeriod
 */
export interface ApiAircraftTypeUtilizationPeriod {
    /**
     * 
     * @type {string}
     * @memberof ApiAircraftTypeUtilizationPeriod
     */
    period?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiAircraftTypeUtilizationPeriod
     */
    averageFlightDistance?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiAircraftTypeUtilizationPeriod
     */
    averageFlightDuration?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiAircraftTypeUtilizationPeriod
     */
    averageFlightsDay?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiAircraftTypeUtilizationPeriod
     */
    averageFlightHoursDay?: number;
}
/**
 * 
 * @export
 * @interface ApiAirlineStatistic
 */
export interface ApiAirlineStatistic {
    /**
     * 
     * @type {string}
     * @memberof ApiAirlineStatistic
     */
    icaoCode?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiAirlineStatistic
     */
    totalFlights?: number;
}
/**
 * 
 * @export
 * @interface ApiAirlineStatistics
 */
export interface ApiAirlineStatistics {
    /**
     * 
     * @type {string}
     * @memberof ApiAirlineStatistics
     */
    day?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiAirlineStatistics
     */
    icaoCode?: string;
    /**
     * 
     * @type {Array<ApiAirlineStatistic>}
     * @memberof ApiAirlineStatistics
     */
    statistics?: Array<ApiAirlineStatistic>;
    /**
     * 
     * @type {Array<ApiAircraftTypeUtilization>}
     * @memberof ApiAirlineStatistics
     */
    aircraftUtilization?: Array<ApiAircraftTypeUtilization>;
    /**
     * 
     * @type {Array<ApiAircraftTypeUtilization>}
     * @memberof ApiAirlineStatistics
     */
    monthAircraftUtilization?: Array<ApiAircraftTypeUtilization>;
}
/**
 * 
 * @export
 * @interface ApiAirport
 */
export interface ApiAirport {
    /**
     * 
     * @type {string}
     * @memberof ApiAirport
     */
    icaoCode?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiAirport
     */
    iataCode?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiAirport
     */
    name?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiAirport
     */
    city?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiAirport
     */
    state?: string;
    /**
     * 
     * @type {boolean}
     * @memberof ApiAirport
     */
    mainAirport?: boolean;
    /**
     * 
     * @type {string}
     * @memberof ApiAirport
     */
    country?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiAirport
     */
    countryIso2?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiAirport
     */
    countryIso3?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiAirport
     */
    elevation?: number;
    /**
     * 
     * @type {Coordinates}
     * @memberof ApiAirport
     */
    coordinates?: Coordinates;
    /**
     * 
     * @type {Array<ApiRunway>}
     * @memberof ApiAirport
     */
    runways?: Array<ApiRunway>;
    /**
     * 
     * @type {string}
     * @memberof ApiAirport
     */
    timeZone?: string;
    /**
     * 
     * @type {Array<ApiRunwayInUse>}
     * @memberof ApiAirport
     */
    takeoffActiveRunways?: Array<ApiRunwayInUse>;
    /**
     * 
     * @type {Array<ApiRunwayInUse>}
     * @memberof ApiAirport
     */
    landingActiveRunways?: Array<ApiRunwayInUse>;
}
/**
 * 
 * @export
 * @interface ApiAirportStatistic
 */
export interface ApiAirportStatistic {
    /**
     * 
     * @type {string}
     * @memberof ApiAirportStatistic
     */
    icaoCode?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiAirportStatistic
     */
    totalFlights?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiAirportStatistic
     */
    totalRegistrations?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiAirportStatistic
     */
    totalAirports?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiAirportStatistic
     */
    totalAirlines?: number;
    /**
     * 
     * @type {{ [key: string]: number; }}
     * @memberof ApiAirportStatistic
     */
    registrations?: { [key: string]: number; };
    /**
     * 
     * @type {{ [key: string]: number; }}
     * @memberof ApiAirportStatistic
     */
    airports?: { [key: string]: number; };
    /**
     * 
     * @type {{ [key: string]: number; }}
     * @memberof ApiAirportStatistic
     */
    airlines?: { [key: string]: number; };
}
/**
 * 
 * @export
 * @interface ApiAirportStatistics
 */
export interface ApiAirportStatistics {
    /**
     * 
     * @type {string}
     * @memberof ApiAirportStatistics
     */
    day?: string;
    /**
     * 
     * @type {Array<ApiAirportStatistic>}
     * @memberof ApiAirportStatistics
     */
    airportStatistics?: Array<ApiAirportStatistic>;
}
/**
 * 
 * @export
 * @interface ApiBusinessJetOperatorStatistic
 */
export interface ApiBusinessJetOperatorStatistic {
    /**
     * 
     * @type {string}
     * @memberof ApiBusinessJetOperatorStatistic
     */
    operator?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiBusinessJetOperatorStatistic
     */
    totalFlights?: number;
}
/**
 * 
 * @export
 * @interface ApiBusinessJetOperatorStatistics
 */
export interface ApiBusinessJetOperatorStatistics {
    /**
     * 
     * @type {string}
     * @memberof ApiBusinessJetOperatorStatistics
     */
    day?: string;
    /**
     * 
     * @type {Array<ApiBusinessJetOperatorStatistic>}
     * @memberof ApiBusinessJetOperatorStatistics
     */
    statistics?: Array<ApiBusinessJetOperatorStatistic>;
}
/**
 * 
 * @export
 * @interface ApiCoordinates
 */
export interface ApiCoordinates {
    /**
     * 
     * @type {number}
     * @memberof ApiCoordinates
     */
    latitude?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiCoordinates
     */
    longitude?: number;
}
/**
 * ATIS is a service that continuously broadcasts aeronautical information around the airport. D-ATIS is the text transcription of the information provided by it.
 * @export
 * @interface ApiDatis
 */
export interface ApiDatis {
    /**
     * 
     * @type {number}
     * @memberof ApiDatis
     */
    datisTime?: number;
    /**
     * 
     * @type {string}
     * @memberof ApiDatis
     */
    header?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiDatis
     */
    body?: string;
}
/**
 * 
 * @export
 * @interface ApiFlight
 */
export interface ApiFlight {
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    callsign?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    flightNumberIata?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    flightNumberIcao?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    aircraftRegistration?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    aircraftModeS?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    aircraftSerialNumber?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    aircraftType?: string;
    /**
     * 
     * @type {Array<string>}
     * @memberof ApiFlight
     */
    aircraftClasses?: Array<string>;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    aircraftTypeDescription?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    airlineIata?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    airlineIcao?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    airlineName?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    depAirportIcao?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    depAirportIata?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    depAirportName?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    depAirportCity?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    depAirportState?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    depAirportCountry?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    depAirportCountryIso2?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    depAirportCountryIso3?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiFlight
     */
    depAirportLatitude?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiFlight
     */
    depAirportLongitude?: number;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    depAirportTz?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    depAirportTzIana?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    depAirportTzDiffUTC?: string;
    /**
     * 
     * @type {Date}
     * @memberof ApiFlight
     */
    scheduledDeparture?: Date;
    /**
     * 
     * @type {Date}
     * @memberof ApiFlight
     */
    estimatedDeparture?: Date;
    /**
     * 
     * @type {Date}
     * @memberof ApiFlight
     */
    estimatedTakeoff?: Date;
    /**
     * 
     * @type {Date}
     * @memberof ApiFlight
     */
    actualDeparture?: Date;
    /**
     * 
     * @type {Date}
     * @memberof ApiFlight
     */
    actualTakeoff?: Date;
    /**
     * 
     * @type {Date}
     * @memberof ApiFlight
     */
    calculatedTakeoff?: Date;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    divAirportIcao?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    divAirportIata?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    divAirportName?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    divAirportCity?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    divAirportState?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    divAirportCountry?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    divAirportCountryIso2?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    divAirportCountryIso3?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiFlight
     */
    divAirportLatitude?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiFlight
     */
    divAirportLongitude?: number;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    divAirportTz?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    divAirportTzIana?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    divAirportTzDiffUTC?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    arrAirportIcao?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    arrAirportIata?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    arrAirportName?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    arrAirportCity?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    arrAirportState?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    arrAirportCountry?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    arrAirportCountryIso2?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    arrAirportCountryIso3?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiFlight
     */
    arrAirportLatitude?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiFlight
     */
    arrAirportLongitude?: number;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    arrAirportTz?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    arrAirportTzIana?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    arrAirportTzDiffUTC?: string;
    /**
     * 
     * @type {Date}
     * @memberof ApiFlight
     */
    scheduledArrival?: Date;
    /**
     * 
     * @type {Date}
     * @memberof ApiFlight
     */
    estimatedArrival?: Date;
    /**
     * 
     * @type {Date}
     * @memberof ApiFlight
     */
    estimatedLanding?: Date;
    /**
     * 
     * @type {Date}
     * @memberof ApiFlight
     */
    actualArrival?: Date;
    /**
     * 
     * @type {Date}
     * @memberof ApiFlight
     */
    actualLanding?: Date;
    /**
     * 
     * @type {Date}
     * @memberof ApiFlight
     */
    calculatedLanding?: Date;
    /**
     * Description of the possible values - CX: cancelled; DY: delayed; EY: early; OT: on time; NS: no status
     * @type {string}
     * @memberof ApiFlight
     */
    departureStatus?: ApiFlight.DepartureStatusEnum;
    /**
     * Description of the possible values - 1: Airline internal; 2: Airline internal; 3: Airline Controlled Delay; 4: Downline Delay; 5: Other; 6: None; 9: Scheduled ground time less than declared minimum ground time; 11: Late check-in - acceptance after deadline; 12: Late check-in - congestion in check-in area; 13: Check-in error - congestion in check-in area; 14: Oversales - booking errors; 15: Boarding - discrepancies and paging missing checked-in passenger; 16: Commercial publicity/passenger convenience - VIP, press, ground meals and missing personal items; 17: Catering order - late or incorrect order given to supplier; 18: Baggage processing - sorting etc.; 21: Documentation - errors etc; 22: Late positioning; 23: Late acceptance; 24: Inadequate packing; 25: Oversales - booking errors; 26: Late preparation in warehouse; 27: Documentation packing - etc; 28: Late positioning; 29: Late acceptance; 31: Aircraft documentation late/inaccurate - weight and balance general declaration pax manifest etc; 32: Loading/unloading - bulky special load cabin load lack of loading staff; 33: Loading equipment - lack of or breakdown e.g. container pallet loader lack of staff; 34: Servicing equipment - lack of or breakdown lack of staff e.g. steps; 35: Aircraft cleaning; 36: Fuelling/defuelling - fuel supplier; 37: Catering - late delivery or loading; 38: Uld - lack of or serviceability; 39: Technical equipment - lack of or breakdown lack of staff e.g. pushback; 41: Aircraft defects; 42: Scheduled maintenance - late release; 43: Non-scheduled; 44: Spares and maintenance; 45: Aog spares - to be carried to another station; 46: Aircraft change - for technical reasons; 47: Standby aircraft - lack of planned standby aircraft for technical reasons; 48: Scheduled cabin configuration/version adjustments; 51: Damage during flight operations - bird or lightning strike, turbulence, heavy or overweight landing, collision during taxiing; 52: Damage during ground operations - collisions (other than during taxiing), loading/off-loading damage, contamination, towing, extreme weather conditions; 55: Departure control; 56: Cargo preparation; 57: Flight plans; 61: Flight plan - late completion or change of flight documentation; 62: Operational requirements - fuel load alteration; 63: Late crew procedures - other than connection and standby (flight deck or entire crew); 64: Flight desk crew shortage - sickness, awaiting standby, flight time limitations, crew meals, valid visa, health documents, etc; 65: Flight deck crew special request - not within operational requirements; 66: Late cabin crew boarding or departure procedures - other than connection and standby; 67: Cabin crew shortage - sickness, awaiting standby, flight time limitations, crew meals, valid visa, health documents, etc; 68: Cabin crew error or special request - not within operational requirements; 69: Captain request for security check - extraordinary; 71: Departure station; 72: Destination station; 73: En route or alternate; 75: De-icing of aircraft - Removal of ice and/or snow frost prevention equipment; 76: Removal of snow ice water and sand from airport; 77: Ground handling impaired by adverse weather conditions; 81: ATFM due to ATC en-route demand/capacity - standard demand/capacity problems; 82: ATFM due to ATC staff / equipment en-route - reduced capacity caused by industrial action or staff shortage or equipment failure, extraordinary demand due to capacity reduction in neighbouring area; 83: ATFM due to restriction at destination airport - airport and/or runway closed due to obstruction, industrial action, staff shortage, political unrest, noise abatement, night curfew, special flights; 84: ATFM due to weather at destination; 85: Mandatory security; 86: Immigration customs health; 87: Airport facilities - parking stands, ramp congestion, lighting, buildings, gate limitations, etc; 88: Restrictions at airport of destination - airport and/or runway closed due to obstruction, industrial action, staff shortage, political unrest, noise abatement, night curfew, special flights; 89: Restrictions at airport of departure with or without ATFM restrictions - incl. Air Traf. Svcs, startup/pushbk, apt and/or runwy closed due to obstruction/weather, industl. actn, staff shortage, political unrest, noise abatement, night curfew, special flts; 91: Load connection - awaiting load from another flight; 92: Through check-in error - passenger and baggage; 93: Aircraft rotation - late arrival of aircraft from another flight or previous sector; 94: Cabin crew rotation - awaiting cabin crew from another flight; 95: Crew rotation - awaiting crew from another flight (flight desk or entire crew); 96: Operational control - rerouting diversion consolidation aircraft change for reason other than technical; 97: Industrial action with own airline; 98: Industrial action outside own airline - excluding A.T.S.; 99: This code shall be used only when it is clear that a reason cannot be matched to any other code
     * @type {string}
     * @memberof ApiFlight
     */
    departureDelayReason?: ApiFlight.DepartureDelayReasonEnum;
    /**
     * Description of the possible values - ARVS: No delays posted; CNCL: Cancelled flight; CXCL: Cancelled; DCSN: Check with airline; DPTS: No delays posted; EOFF: Estimated Wheels Up/Airborne; EON: Estimated Wheels Down/Touchdown; ETA: Estimated time of arrival; ETD: Estimated time of departure; IN: Arrived in the gate; LX: Cancelled leg; NA: Not Available; NO: No-op; OFF: Departed off the ground; ON: Arrived on the ground; OUT: Departed out of the gate; RFA: Return from Airborne; RTR: Return to Ramp; SCHD: Schedule Change
     * @type {string}
     * @memberof ApiFlight
     */
    departureDelayDetail?: ApiFlight.DepartureDelayDetailEnum;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    departureGate?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    departureTerminal?: string;
    /**
     * Description of the possible values - CX: cancelled; DY: delayed; EY: early; OT: on time; NS: no status
     * @type {string}
     * @memberof ApiFlight
     */
    arrivalStatus?: ApiFlight.ArrivalStatusEnum;
    /**
     * Description of the possible values - 1: Airline internal; 2: Airline internal; 3: Airline Controlled Delay; 4: Downline Delay; 5: Other; 6: None; 9: Scheduled ground time less than declared minimum ground time; 11: Late check-in - acceptance after deadline; 12: Late check-in - congestion in check-in area; 13: Check-in error - congestion in check-in area; 14: Oversales - booking errors; 15: Boarding - discrepancies and paging missing checked-in passenger; 16: Commercial publicity/passenger convenience - VIP, press, ground meals and missing personal items; 17: Catering order - late or incorrect order given to supplier; 18: Baggage processing - sorting etc.; 21: Documentation - errors etc; 22: Late positioning; 23: Late acceptance; 24: Inadequate packing; 25: Oversales - booking errors; 26: Late preparation in warehouse; 27: Documentation packing - etc; 28: Late positioning; 29: Late acceptance; 31: Aircraft documentation late/inaccurate - weight and balance general declaration pax manifest etc; 32: Loading/unloading - bulky special load cabin load lack of loading staff; 33: Loading equipment - lack of or breakdown e.g. container pallet loader lack of staff; 34: Servicing equipment - lack of or breakdown lack of staff e.g. steps; 35: Aircraft cleaning; 36: Fuelling/defuelling - fuel supplier; 37: Catering - late delivery or loading; 38: Uld - lack of or serviceability; 39: Technical equipment - lack of or breakdown lack of staff e.g. pushback; 41: Aircraft defects; 42: Scheduled maintenance - late release; 43: Non-scheduled; 44: Spares and maintenance; 45: Aog spares - to be carried to another station; 46: Aircraft change - for technical reasons; 47: Standby aircraft - lack of planned standby aircraft for technical reasons; 48: Scheduled cabin configuration/version adjustments; 51: Damage during flight operations - bird or lightning strike, turbulence, heavy or overweight landing, collision during taxiing; 52: Damage during ground operations - collisions (other than during taxiing), loading/off-loading damage, contamination, towing, extreme weather conditions; 55: Departure control; 56: Cargo preparation; 57: Flight plans; 61: Flight plan - late completion or change of flight documentation; 62: Operational requirements - fuel load alteration; 63: Late crew procedures - other than connection and standby (flight deck or entire crew); 64: Flight desk crew shortage - sickness, awaiting standby, flight time limitations, crew meals, valid visa, health documents, etc; 65: Flight deck crew special request - not within operational requirements; 66: Late cabin crew boarding or departure procedures - other than connection and standby; 67: Cabin crew shortage - sickness, awaiting standby, flight time limitations, crew meals, valid visa, health documents, etc; 68: Cabin crew error or special request - not within operational requirements; 69: Captain request for security check - extraordinary; 71: Departure station; 72: Destination station; 73: En route or alternate; 75: De-icing of aircraft - Removal of ice and/or snow frost prevention equipment; 76: Removal of snow ice water and sand from airport; 77: Ground handling impaired by adverse weather conditions; 81: ATFM due to ATC en-route demand/capacity - standard demand/capacity problems; 82: ATFM due to ATC staff / equipment en-route - reduced capacity caused by industrial action or staff shortage or equipment failure, extraordinary demand due to capacity reduction in neighbouring area; 83: ATFM due to restriction at destination airport - airport and/or runway closed due to obstruction, industrial action, staff shortage, political unrest, noise abatement, night curfew, special flights; 84: ATFM due to weather at destination; 85: Mandatory security; 86: Immigration customs health; 87: Airport facilities - parking stands, ramp congestion, lighting, buildings, gate limitations, etc; 88: Restrictions at airport of destination - airport and/or runway closed due to obstruction, industrial action, staff shortage, political unrest, noise abatement, night curfew, special flights; 89: Restrictions at airport of departure with or without ATFM restrictions - incl. Air Traf. Svcs, startup/pushbk, apt and/or runwy closed due to obstruction/weather, industl. actn, staff shortage, political unrest, noise abatement, night curfew, special flts; 91: Load connection - awaiting load from another flight; 92: Through check-in error - passenger and baggage; 93: Aircraft rotation - late arrival of aircraft from another flight or previous sector; 94: Cabin crew rotation - awaiting cabin crew from another flight; 95: Crew rotation - awaiting crew from another flight (flight desk or entire crew); 96: Operational control - rerouting diversion consolidation aircraft change for reason other than technical; 97: Industrial action with own airline; 98: Industrial action outside own airline - excluding A.T.S.; 99: This code shall be used only when it is clear that a reason cannot be matched to any other code
     * @type {string}
     * @memberof ApiFlight
     */
    arrivalDelayReason?: ApiFlight.ArrivalDelayReasonEnum;
    /**
     * Description of the possible values - ARVS: No delays posted; CNCL: Cancelled flight; CXCL: Cancelled; DCSN: Check with airline; DPTS: No delays posted; EOFF: Estimated Wheels Up/Airborne; EON: Estimated Wheels Down/Touchdown; ETA: Estimated time of arrival; ETD: Estimated time of departure; IN: Arrived in the gate; LX: Cancelled leg; NA: Not Available; NO: No-op; OFF: Departed off the ground; ON: Arrived on the ground; OUT: Departed out of the gate; RFA: Return from Airborne; RTR: Return to Ramp; SCHD: Schedule Change
     * @type {string}
     * @memberof ApiFlight
     */
    arrivalDelayDetail?: ApiFlight.ArrivalDelayDetailEnum;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    arrivalGate?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    arrivalTerminal?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    arrivalBaggageClaim?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiFlight
     */
    groundSpeed?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiFlight
     */
    heading?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiFlight
     */
    altitude?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiFlight
     */
    verticalRate?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiFlight
     */
    latitude?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiFlight
     */
    longitude?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiFlight
     */
    squawkCode?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiFlight
     */
    distance?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiFlight
     */
    duration?: number;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    source?: string;
    /**
     * 
     * @type {Date}
     * @memberof ApiFlight
     */
    created?: Date;
    /**
     * 
     * @type {Date}
     * @memberof ApiFlight
     */
    updated?: Date;
    /**
     * 
     * @type {Array<ApiTrail>}
     * @memberof ApiFlight
     */
    positions?: Array<ApiTrail>;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    flightUrl?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    flightKml?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    flightCSV?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    flightGeoJSON?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    icaoRoute?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    codeshares?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiFlight
     */
    status?: ApiFlight.StatusEnum;
}

/**
 * @export
 * @namespace ApiFlight
 */
export namespace ApiFlight {
    /**
     * @export
     * @enum {string}
     */
    export enum DepartureStatusEnum {
        CX = <any> 'CX',
        DY = <any> 'DY',
        EY = <any> 'EY',
        OT = <any> 'OT',
        NS = <any> 'NS'
    }
    /**
     * @export
     * @enum {string}
     */
    export enum DepartureDelayReasonEnum {
        _1 = <any> '1',
        _2 = <any> '2',
        _3 = <any> '3',
        _4 = <any> '4',
        _5 = <any> '5',
        _6 = <any> '6',
        _9 = <any> '9',
        _11 = <any> '11',
        _12 = <any> '12',
        _13 = <any> '13',
        _14 = <any> '14',
        _15 = <any> '15',
        _16 = <any> '16',
        _17 = <any> '17',
        _18 = <any> '18',
        _21 = <any> '21',
        _22 = <any> '22',
        _23 = <any> '23',
        _24 = <any> '24',
        _25 = <any> '25',
        _26 = <any> '26',
        _27 = <any> '27',
        _28 = <any> '28',
        _29 = <any> '29',
        _31 = <any> '31',
        _32 = <any> '32',
        _33 = <any> '33',
        _34 = <any> '34',
        _35 = <any> '35',
        _36 = <any> '36',
        _37 = <any> '37',
        _38 = <any> '38',
        _39 = <any> '39',
        _41 = <any> '41',
        _42 = <any> '42',
        _43 = <any> '43',
        _44 = <any> '44',
        _45 = <any> '45',
        _46 = <any> '46',
        _47 = <any> '47',
        _48 = <any> '48',
        _51 = <any> '51',
        _52 = <any> '52',
        _55 = <any> '55',
        _56 = <any> '56',
        _57 = <any> '57',
        _61 = <any> '61',
        _62 = <any> '62',
        _63 = <any> '63',
        _64 = <any> '64',
        _65 = <any> '65',
        _66 = <any> '66',
        _67 = <any> '67',
        _68 = <any> '68',
        _69 = <any> '69',
        _71 = <any> '71',
        _72 = <any> '72',
        _73 = <any> '73',
        _75 = <any> '75',
        _76 = <any> '76',
        _77 = <any> '77',
        _81 = <any> '81',
        _82 = <any> '82',
        _83 = <any> '83',
        _84 = <any> '84',
        _85 = <any> '85',
        _86 = <any> '86',
        _87 = <any> '87',
        _88 = <any> '88',
        _89 = <any> '89',
        _91 = <any> '91',
        _92 = <any> '92',
        _93 = <any> '93',
        _94 = <any> '94',
        _95 = <any> '95',
        _96 = <any> '96',
        _97 = <any> '97',
        _98 = <any> '98',
        _99 = <any> '99'
    }
    /**
     * @export
     * @enum {string}
     */
    export enum DepartureDelayDetailEnum {
        ARVS = <any> 'ARVS',
        CNCL = <any> 'CNCL',
        CXCL = <any> 'CXCL',
        DCSN = <any> 'DCSN',
        DPTS = <any> 'DPTS',
        EOFF = <any> 'EOFF',
        EON = <any> 'EON',
        ETA = <any> 'ETA',
        ETD = <any> 'ETD',
        IN = <any> 'IN',
        LX = <any> 'LX',
        NA = <any> 'NA',
        NO = <any> 'NO',
        OFF = <any> 'OFF',
        ON = <any> 'ON',
        OUT = <any> 'OUT',
        RFA = <any> 'RFA',
        RTR = <any> 'RTR',
        SCHD = <any> 'SCHD'
    }
    /**
     * @export
     * @enum {string}
     */
    export enum ArrivalStatusEnum {
        CX = <any> 'CX',
        DY = <any> 'DY',
        EY = <any> 'EY',
        OT = <any> 'OT',
        NS = <any> 'NS'
    }
    /**
     * @export
     * @enum {string}
     */
    export enum ArrivalDelayReasonEnum {
        _1 = <any> '1',
        _2 = <any> '2',
        _3 = <any> '3',
        _4 = <any> '4',
        _5 = <any> '5',
        _6 = <any> '6',
        _9 = <any> '9',
        _11 = <any> '11',
        _12 = <any> '12',
        _13 = <any> '13',
        _14 = <any> '14',
        _15 = <any> '15',
        _16 = <any> '16',
        _17 = <any> '17',
        _18 = <any> '18',
        _21 = <any> '21',
        _22 = <any> '22',
        _23 = <any> '23',
        _24 = <any> '24',
        _25 = <any> '25',
        _26 = <any> '26',
        _27 = <any> '27',
        _28 = <any> '28',
        _29 = <any> '29',
        _31 = <any> '31',
        _32 = <any> '32',
        _33 = <any> '33',
        _34 = <any> '34',
        _35 = <any> '35',
        _36 = <any> '36',
        _37 = <any> '37',
        _38 = <any> '38',
        _39 = <any> '39',
        _41 = <any> '41',
        _42 = <any> '42',
        _43 = <any> '43',
        _44 = <any> '44',
        _45 = <any> '45',
        _46 = <any> '46',
        _47 = <any> '47',
        _48 = <any> '48',
        _51 = <any> '51',
        _52 = <any> '52',
        _55 = <any> '55',
        _56 = <any> '56',
        _57 = <any> '57',
        _61 = <any> '61',
        _62 = <any> '62',
        _63 = <any> '63',
        _64 = <any> '64',
        _65 = <any> '65',
        _66 = <any> '66',
        _67 = <any> '67',
        _68 = <any> '68',
        _69 = <any> '69',
        _71 = <any> '71',
        _72 = <any> '72',
        _73 = <any> '73',
        _75 = <any> '75',
        _76 = <any> '76',
        _77 = <any> '77',
        _81 = <any> '81',
        _82 = <any> '82',
        _83 = <any> '83',
        _84 = <any> '84',
        _85 = <any> '85',
        _86 = <any> '86',
        _87 = <any> '87',
        _88 = <any> '88',
        _89 = <any> '89',
        _91 = <any> '91',
        _92 = <any> '92',
        _93 = <any> '93',
        _94 = <any> '94',
        _95 = <any> '95',
        _96 = <any> '96',
        _97 = <any> '97',
        _98 = <any> '98',
        _99 = <any> '99'
    }
    /**
     * @export
     * @enum {string}
     */
    export enum ArrivalDelayDetailEnum {
        ARVS = <any> 'ARVS',
        CNCL = <any> 'CNCL',
        CXCL = <any> 'CXCL',
        DCSN = <any> 'DCSN',
        DPTS = <any> 'DPTS',
        EOFF = <any> 'EOFF',
        EON = <any> 'EON',
        ETA = <any> 'ETA',
        ETD = <any> 'ETD',
        IN = <any> 'IN',
        LX = <any> 'LX',
        NA = <any> 'NA',
        NO = <any> 'NO',
        OFF = <any> 'OFF',
        ON = <any> 'ON',
        OUT = <any> 'OUT',
        RFA = <any> 'RFA',
        RTR = <any> 'RTR',
        SCHD = <any> 'SCHD'
    }
    /**
     * @export
     * @enum {string}
     */
    export enum StatusEnum {
        INFLIGHT = <any> 'IN_FLIGHT',
        CANCELLED = <any> 'CANCELLED',
        SCHEDULED = <any> 'SCHEDULED',
        LANDED = <any> 'LANDED',
        ONGROUND = <any> 'ON_GROUND',
        UNKNOWN = <any> 'UNKNOWN'
    }
}
/**
 * 
 * @export
 * @interface ApiFlightRouteStatistic
 */
export interface ApiFlightRouteStatistic {
    /**
     * 
     * @type {string}
     * @memberof ApiFlightRouteStatistic
     */
    route?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiFlightRouteStatistic
     */
    total?: number;
}
/**
 * 
 * @export
 * @interface ApiFlightsStatistic
 */
export interface ApiFlightsStatistic {
    /**
     * 
     * @type {string}
     * @memberof ApiFlightsStatistic
     */
    day?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiFlightsStatistic
     */
    total?: number;
    /**
     * 
     * @type {Array<ApiFlightRouteStatistic>}
     * @memberof ApiFlightsStatistic
     */
    routes?: Array<ApiFlightRouteStatistic>;
}
/**
 * 
 * @export
 * @interface ApiJetModelStatistic
 */
export interface ApiJetModelStatistic {
    /**
     * 
     * @type {string}
     * @memberof ApiJetModelStatistic
     */
    model?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiJetModelStatistic
     */
    totalFlights?: number;
}
/**
 * 
 * @export
 * @interface ApiJetModelStatistics
 */
export interface ApiJetModelStatistics {
    /**
     * 
     * @type {string}
     * @memberof ApiJetModelStatistics
     */
    day?: string;
    /**
     * 
     * @type {Array<ApiJetModelStatistic>}
     * @memberof ApiJetModelStatistics
     */
    statistics?: Array<ApiJetModelStatistic>;
}
/**
 * METARs provide a report of the current weather conditions in the vicinity of an aerodrome
 * @export
 * @interface ApiMetar
 */
export interface ApiMetar {
    /**
     * 
     * @type {Date}
     * @memberof ApiMetar
     */
    observationTime?: Date;
    /**
     * 
     * @type {ApiCoordinates}
     * @memberof ApiMetar
     */
    coordinates?: ApiCoordinates;
    /**
     * 
     * @type {number}
     * @memberof ApiMetar
     */
    temperature?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiMetar
     */
    dewPoint?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiMetar
     */
    windDirection?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiMetar
     */
    windSpeed?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiMetar
     */
    visibility?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiMetar
     */
    altimeter?: number;
    /**
     * 
     * @type {boolean}
     * @memberof ApiMetar
     */
    auto?: boolean;
    /**
     * 
     * @type {string}
     * @memberof ApiMetar
     */
    wx?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiMetar
     */
    skyCover?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiMetar
     */
    cloudBase?: number;
    /**
     * 
     * @type {string}
     * @memberof ApiMetar
     */
    flightCategory?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiMetar
     */
    metarType?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiMetar
     */
    elevation?: number;
    /**
     * 
     * @type {string}
     * @memberof ApiMetar
     */
    rawText?: string;
    /**
     * 
     * @type {Date}
     * @memberof ApiMetar
     */
    observationHour?: Date;
}
/**
 * 
 * @export
 * @interface ApiNatPacTrack
 */
export interface ApiNatPacTrack {
    /**
     * 
     * @type {string}
     * @memberof ApiNatPacTrack
     */
    identifier?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiNatPacTrack
     */
    issuedDate?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiNatPacTrack
     */
    validFrom?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiNatPacTrack
     */
    validUntil?: number;
    /**
     * 
     * @type {string}
     * @memberof ApiNatPacTrack
     */
    track?: string;
    /**
     * 
     * @type {Array<ApiTrackWaypoint>}
     * @memberof ApiNatPacTrack
     */
    waypoints?: Array<ApiTrackWaypoint>;
}
/**
 * NOTAMs are a way of local aviation authorities alerting pilots of potential hazards
 * @export
 * @interface ApiNotam
 */
export interface ApiNotam {
    /**
     * 
     * @type {number}
     * @memberof ApiNotam
     */
    number?: number;
    /**
     * 
     * @type {string}
     * @memberof ApiNotam
     */
    id?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiNotam
     */
    notamClass?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiNotam
     */
    year?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiNotam
     */
    type?: string;
    /**
     * 
     * @type {Date}
     * @memberof ApiNotam
     */
    effectiveStart?: Date;
    /**
     * 
     * @type {Date}
     * @memberof ApiNotam
     */
    effectiveEnd?: Date;
    /**
     * 
     * @type {string}
     * @memberof ApiNotam
     */
    icaoLocation?: string;
    /**
     * 
     * @type {Date}
     * @memberof ApiNotam
     */
    issued?: Date;
    /**
     * 
     * @type {string}
     * @memberof ApiNotam
     */
    affectedFir?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiNotam
     */
    minimumFlightLevel?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiNotam
     */
    maximumFlightLevel?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiNotam
     */
    radius?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiNotam
     */
    location?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiNotam
     */
    text?: string;
    /**
     * 
     * @type {Array<ApiNotamTranslation>}
     * @memberof ApiNotam
     */
    translations?: Array<ApiNotamTranslation>;
}
/**
 * 
 * @export
 * @interface ApiNotamTranslation
 */
export interface ApiNotamTranslation {
    /**
     * 
     * @type {string}
     * @memberof ApiNotamTranslation
     */
    type?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiNotamTranslation
     */
    text?: string;
}
/**
 * 
 * @export
 * @interface ApiRunway
 */
export interface ApiRunway {
    /**
     * 
     * @type {string}
     * @memberof ApiRunway
     */
    name?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiRunway
     */
    course?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiRunway
     */
    length?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiRunway
     */
    elevation?: number;
    /**
     * 
     * @type {Coordinates}
     * @memberof ApiRunway
     */
    coordinates?: Coordinates;
    /**
     * 
     * @type {string}
     * @memberof ApiRunway
     */
    ilsCourse?: string;
}
/**
 * 
 * @export
 * @interface ApiRunwayInUse
 */
export interface ApiRunwayInUse {
    /**
     * 
     * @type {string}
     * @memberof ApiRunwayInUse
     */
    name?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiRunwayInUse
     */
    totalLandings3h?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiRunwayInUse
     */
    percentageLandings3h?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiRunwayInUse
     */
    totalTakeoffs3h?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiRunwayInUse
     */
    percentageTakeoffs3h?: number;
}
/**
 * 
 * @export
 * @interface ApiStatisticAirport
 */
export interface ApiStatisticAirport {
    /**
     * 
     * @type {string}
     * @memberof ApiStatisticAirport
     */
    icaoCode?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiStatisticAirport
     */
    movements?: number;
}
/**
 * Weather forecast Information provided by airports to serve the surrounding air traffic. TAF reports are updated several times throughout the day to ensure that pilots have access to the most up-to-date information as possible
 * @export
 * @interface ApiTaf
 */
export interface ApiTaf {
    /**
     * 
     * @type {Date}
     * @memberof ApiTaf
     */
    issueTime?: Date;
    /**
     * 
     * @type {Date}
     * @memberof ApiTaf
     */
    bulletinTime?: Date;
    /**
     * 
     * @type {Date}
     * @memberof ApiTaf
     */
    validFrom?: Date;
    /**
     * 
     * @type {Date}
     * @memberof ApiTaf
     */
    validUntil?: Date;
    /**
     * 
     * @type {ApiCoordinates}
     * @memberof ApiTaf
     */
    coordinates?: ApiCoordinates;
    /**
     * 
     * @type {number}
     * @memberof ApiTaf
     */
    elevation?: number;
    /**
     * 
     * @type {Array<ApiTafForecast>}
     * @memberof ApiTaf
     */
    forecast?: Array<ApiTafForecast>;
}
/**
 * Single forecast with a valid to and from date/time
 * @export
 * @interface ApiTafForecast
 */
export interface ApiTafForecast {
    /**
     * 
     * @type {Date}
     * @memberof ApiTafForecast
     */
    validFom?: Date;
    /**
     * 
     * @type {Date}
     * @memberof ApiTafForecast
     */
    validUntil?: Date;
    /**
     * 
     * @type {number}
     * @memberof ApiTafForecast
     */
    windDirection?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiTafForecast
     */
    windSpeed?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiTafForecast
     */
    windGust?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiTafForecast
     */
    visibility?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiTafForecast
     */
    altimeter?: number;
    /**
     * 
     * @type {string}
     * @memberof ApiTafForecast
     */
    wx?: string;
    /**
     * 
     * @type {Array<ApiTafSkyCondition>}
     * @memberof ApiTafForecast
     */
    skyCondition?: Array<ApiTafSkyCondition>;
    /**
     * 
     * @type {string}
     * @memberof ApiTafForecast
     */
    icingCondition?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiTafForecast
     */
    turbulenceCondition?: string;
}
/**
 * Forecast of sky condition
 * @export
 * @interface ApiTafSkyCondition
 */
export interface ApiTafSkyCondition {
    /**
     * 
     * @type {string}
     * @memberof ApiTafSkyCondition
     */
    skyCover?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiTafSkyCondition
     */
    cloudBase?: number;
}
/**
 * 
 * @export
 * @interface ApiTrackWaypoint
 */
export interface ApiTrackWaypoint {
    /**
     * 
     * @type {string}
     * @memberof ApiTrackWaypoint
     */
    name?: string;
    /**
     * 
     * @type {number}
     * @memberof ApiTrackWaypoint
     */
    latitude?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiTrackWaypoint
     */
    longitude?: number;
}
/**
 * 
 * @export
 * @interface ApiTrail
 */
export interface ApiTrail {
    /**
     * 
     * @type {number}
     * @memberof ApiTrail
     */
    groundSpeed?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiTrail
     */
    heading?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiTrail
     */
    altitude?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiTrail
     */
    verticalRate?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiTrail
     */
    latitude?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiTrail
     */
    longitude?: number;
    /**
     * 
     * @type {number}
     * @memberof ApiTrail
     */
    squawkCode?: number;
    /**
     * 
     * @type {string}
     * @memberof ApiTrail
     */
    source?: string;
    /**
     * 
     * @type {Date}
     * @memberof ApiTrail
     */
    timestamp?: Date;
}
/**
 * 
 * @export
 * @interface BillingStatusResponse
 */
export interface BillingStatusResponse {
    /**
     * 
     * @type {number}
     * @memberof BillingStatusResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof BillingStatusResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof BillingStatusResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof BillingStatusResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof BillingStatusResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof BillingStatusResponse
     */
    availableCredit?: number;
    /**
     * 
     * @type {number}
     * @memberof BillingStatusResponse
     */
    subscriptionAmount?: number;
    /**
     * 
     * @type {number}
     * @memberof BillingStatusResponse
     */
    usedCredit?: number;
    /**
     * 
     * @type {boolean}
     * @memberof BillingStatusResponse
     */
    active?: boolean;
    /**
     * 
     * @type {boolean}
     * @memberof BillingStatusResponse
     */
    autoScaleEnabled?: boolean;
    /**
     * 
     * @type {Date}
     * @memberof BillingStatusResponse
     */
    currentBillingCycleStart?: Date;
    /**
     * 
     * @type {Date}
     * @memberof BillingStatusResponse
     */
    currentBillingCycleEnd?: Date;
    /**
     * 
     * @type {number}
     * @memberof BillingStatusResponse
     */
    lowestDayUsageAmount?: number;
    /**
     * 
     * @type {string}
     * @memberof BillingStatusResponse
     */
    lowestDayUsageDate?: string;
    /**
     * 
     * @type {number}
     * @memberof BillingStatusResponse
     */
    highestDayUsageAmount?: number;
    /**
     * 
     * @type {string}
     * @memberof BillingStatusResponse
     */
    highestDayUsageDate?: string;
}
/**
 * 
 * @export
 * @interface BillingTokenDailyStats
 */
export interface BillingTokenDailyStats {
    /**
     * 
     * @type {string}
     * @memberof BillingTokenDailyStats
     */
    day?: string;
    /**
     * 
     * @type {number}
     * @memberof BillingTokenDailyStats
     */
    totalCalls?: number;
    /**
     * 
     * @type {number}
     * @memberof BillingTokenDailyStats
     */
    totalCredit?: number;
}
/**
 * 
 * @export
 * @interface BillingUsageResponse
 */
export interface BillingUsageResponse {
    /**
     * 
     * @type {number}
     * @memberof BillingUsageResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof BillingUsageResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof BillingUsageResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof BillingUsageResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof BillingUsageResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {Array<BillingTokenDailyStats>}
     * @memberof BillingUsageResponse
     */
    dailyUsage?: Array<BillingTokenDailyStats>;
}
/**
 * 
 * @export
 * @interface BusinessJetModelStatisticsResponse
 */
export interface BusinessJetModelStatisticsResponse {
    /**
     * 
     * @type {number}
     * @memberof BusinessJetModelStatisticsResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof BusinessJetModelStatisticsResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof BusinessJetModelStatisticsResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof BusinessJetModelStatisticsResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof BusinessJetModelStatisticsResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {Array<ApiJetModelStatistics>}
     * @memberof BusinessJetModelStatisticsResponse
     */
    statistics?: Array<ApiJetModelStatistics>;
}
/**
 * 
 * @export
 * @interface BusinessJetOperatorStatisticsResponse
 */
export interface BusinessJetOperatorStatisticsResponse {
    /**
     * 
     * @type {number}
     * @memberof BusinessJetOperatorStatisticsResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof BusinessJetOperatorStatisticsResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof BusinessJetOperatorStatisticsResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof BusinessJetOperatorStatisticsResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof BusinessJetOperatorStatisticsResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {Array<ApiBusinessJetOperatorStatistics>}
     * @memberof BusinessJetOperatorStatisticsResponse
     */
    statistics?: Array<ApiBusinessJetOperatorStatistics>;
}
/**
 * 
 * @export
 * @interface Coordinates
 */
export interface Coordinates {
    /**
     * 
     * @type {number}
     * @memberof Coordinates
     */
    latitude?: number;
    /**
     * 
     * @type {number}
     * @memberof Coordinates
     */
    longitude?: number;
}
/**
 * 
 * @export
 * @interface FlightsQuery
 */
export interface FlightsQuery {
    /**
     * 
     * @type {number}
     * @memberof FlightsQuery
     */
    pageSize?: number;
    /**
     * 
     * @type {number}
     * @memberof FlightsQuery
     */
    page?: number;
    /**
     * 
     * @type {Date}
     * @memberof FlightsQuery
     */
    fromDate?: Date;
    /**
     * 
     * @type {Date}
     * @memberof FlightsQuery
     */
    toDate?: Date;
    /**
     * 
     * @type {Date}
     * @memberof FlightsQuery
     */
    departureFromDate?: Date;
    /**
     * 
     * @type {Date}
     * @memberof FlightsQuery
     */
    departureToDate?: Date;
    /**
     * 
     * @type {Date}
     * @memberof FlightsQuery
     */
    arrivalFromDate?: Date;
    /**
     * 
     * @type {Date}
     * @memberof FlightsQuery
     */
    arrivalToDate?: Date;
    /**
     * 
     * @type {Array<string>}
     * @memberof FlightsQuery
     */
    registrations?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof FlightsQuery
     */
    flightIds?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof FlightsQuery
     */
    modeSHexCodes?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof FlightsQuery
     */
    serialNumbers?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof FlightsQuery
     */
    airlines?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof FlightsQuery
     */
    toAirports?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof FlightsQuery
     */
    toCountries?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof FlightsQuery
     */
    fromAirports?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof FlightsQuery
     */
    fromCountries?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof FlightsQuery
     */
    divertedToAirports?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof FlightsQuery
     */
    divertedToCountries?: Array<string>;
    /**
     * 
     * @type {boolean}
     * @memberof FlightsQuery
     */
    includeFlightPaths?: boolean;
    /**
     * 
     * @type {boolean}
     * @memberof FlightsQuery
     */
    includeFlightUrls?: boolean;
    /**
     * 
     * @type {Array<string>}
     * @memberof FlightsQuery
     */
    aircraftClasses?: Array<string>;
}
/**
 * 
 * @export
 * @interface FlightsResponse
 */
export interface FlightsResponse {
    /**
     * 
     * @type {number}
     * @memberof FlightsResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof FlightsResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof FlightsResponse
     */
    comment?: string;
    /**
     * 
     * @type {Array<ApiFlight>}
     * @memberof FlightsResponse
     */
    flights?: Array<ApiFlight>;
    /**
     * 
     * @type {number}
     * @memberof FlightsResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof FlightsResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof FlightsResponse
     */
    totaPages?: number;
    /**
     * 
     * @type {number}
     * @memberof FlightsResponse
     */
    pageSize?: number;
    /**
     * 
     * @type {number}
     * @memberof FlightsResponse
     */
    currentPage?: number;
}
/**
 * 
 * @export
 * @interface FlightsStatisticsResponse
 */
export interface FlightsStatisticsResponse {
    /**
     * 
     * @type {number}
     * @memberof FlightsStatisticsResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof FlightsStatisticsResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof FlightsStatisticsResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof FlightsStatisticsResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof FlightsStatisticsResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {Array<ApiFlightsStatistic>}
     * @memberof FlightsStatisticsResponse
     */
    statistics?: Array<ApiFlightsStatistic>;
}
/**
 * 
 * @export
 * @interface GeoSearchQuery
 */
export interface GeoSearchQuery {
    /**
     * 
     * @type {number}
     * @memberof GeoSearchQuery
     */
    pageSize?: number;
    /**
     * 
     * @type {number}
     * @memberof GeoSearchQuery
     */
    page?: number;
    /**
     * 
     * @type {number}
     * @memberof GeoSearchQuery
     */
    minLatitude: number;
    /**
     * 
     * @type {number}
     * @memberof GeoSearchQuery
     */
    maxLatitude: number;
    /**
     * 
     * @type {number}
     * @memberof GeoSearchQuery
     */
    minLongitude: number;
    /**
     * 
     * @type {number}
     * @memberof GeoSearchQuery
     */
    maxLongitude: number;
    /**
     * 
     * @type {number}
     * @memberof GeoSearchQuery
     */
    belowAltitude?: number;
    /**
     * 
     * @type {number}
     * @memberof GeoSearchQuery
     */
    aboveAltitude?: number;
    /**
     * 
     * @type {boolean}
     * @memberof GeoSearchQuery
     */
    includeFlightPaths?: boolean;
    /**
     * 
     * @type {Array<string>}
     * @memberof GeoSearchQuery
     */
    registrations?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof GeoSearchQuery
     */
    modeSHexCodes?: Array<string>;
    /**
     * 
     * @type {Date}
     * @memberof GeoSearchQuery
     */
    fromDate: Date;
    /**
     * 
     * @type {Date}
     * @memberof GeoSearchQuery
     */
    toDate: Date;
    /**
     * 
     * @type {Array<string>}
     * @memberof GeoSearchQuery
     */
    airlines?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof GeoSearchQuery
     */
    aircraftTypes?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof GeoSearchQuery
     */
    aircraftClasses?: Array<string>;
}
/**
 * 
 * @export
 * @interface GetAircraftResponse
 */
export interface GetAircraftResponse {
    /**
     * 
     * @type {number}
     * @memberof GetAircraftResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof GetAircraftResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof GetAircraftResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof GetAircraftResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof GetAircraftResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {ApiAircraft}
     * @memberof GetAircraftResponse
     */
    aircraft?: ApiAircraft;
}
/**
 * 
 * @export
 * @interface GetAirportResponse
 */
export interface GetAirportResponse {
    /**
     * 
     * @type {number}
     * @memberof GetAirportResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof GetAirportResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof GetAirportResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof GetAirportResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof GetAirportResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {ApiAirport}
     * @memberof GetAirportResponse
     */
    airport?: ApiAirport;
}
/**
 * 
 * @export
 * @interface GetAirportsResponse
 */
export interface GetAirportsResponse {
    /**
     * 
     * @type {number}
     * @memberof GetAirportsResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof GetAirportsResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof GetAirportsResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof GetAirportsResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof GetAirportsResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {Array<ApiAirport>}
     * @memberof GetAirportsResponse
     */
    airports?: Array<ApiAirport>;
}
/**
 * 
 * @export
 * @interface GetDatisResponse
 */
export interface GetDatisResponse {
    /**
     * 
     * @type {number}
     * @memberof GetDatisResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof GetDatisResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof GetDatisResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof GetDatisResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof GetDatisResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {ApiDatis}
     * @memberof GetDatisResponse
     */
    apiDatis?: ApiDatis;
}
/**
 * 
 * @export
 * @interface GetMetarResponse
 */
export interface GetMetarResponse {
    /**
     * 
     * @type {number}
     * @memberof GetMetarResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof GetMetarResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof GetMetarResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof GetMetarResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof GetMetarResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {ApiMetar}
     * @memberof GetMetarResponse
     */
    apiMetar?: ApiMetar;
}
/**
 * 
 * @export
 * @interface GetNatPacTracksResponse
 */
export interface GetNatPacTracksResponse {
    /**
     * 
     * @type {number}
     * @memberof GetNatPacTracksResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof GetNatPacTracksResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof GetNatPacTracksResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof GetNatPacTracksResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof GetNatPacTracksResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {Array<ApiNatPacTrack>}
     * @memberof GetNatPacTracksResponse
     */
    tracks?: Array<ApiNatPacTrack>;
}
/**
 * 
 * @export
 * @interface GetNotamsResponse
 */
export interface GetNotamsResponse {
    /**
     * 
     * @type {number}
     * @memberof GetNotamsResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof GetNotamsResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof GetNotamsResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof GetNotamsResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof GetNotamsResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {Array<ApiNotam>}
     * @memberof GetNotamsResponse
     */
    apiNotams?: Array<ApiNotam>;
}
/**
 * 
 * @export
 * @interface GetTafResponse
 */
export interface GetTafResponse {
    /**
     * 
     * @type {number}
     * @memberof GetTafResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof GetTafResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof GetTafResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof GetTafResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof GetTafResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {ApiTaf}
     * @memberof GetTafResponse
     */
    apiTaf?: ApiTaf;
}
/**
 * 
 * @export
 * @interface RtAircraftPositionQuery
 */
export interface RtAircraftPositionQuery {
    /**
     * 
     * @type {Array<string>}
     * @memberof RtAircraftPositionQuery
     */
    registrations?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof RtAircraftPositionQuery
     */
    modeSHexCodes?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof RtAircraftPositionQuery
     */
    serialNumbers?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof RtAircraftPositionQuery
     */
    flightIds?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof RtAircraftPositionQuery
     */
    airlines?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof RtAircraftPositionQuery
     */
    aircraftTypes?: Array<string>;
    /**
     * 
     * @type {boolean}
     * @memberof RtAircraftPositionQuery
     */
    incLastKnownPos?: boolean;
    /**
     * 
     * @type {number}
     * @memberof RtAircraftPositionQuery
     */
    minLatitude?: number;
    /**
     * 
     * @type {number}
     * @memberof RtAircraftPositionQuery
     */
    maxLatitude?: number;
    /**
     * 
     * @type {number}
     * @memberof RtAircraftPositionQuery
     */
    minLongitude?: number;
    /**
     * 
     * @type {number}
     * @memberof RtAircraftPositionQuery
     */
    maxLongitude?: number;
    /**
     * 
     * @type {Array<string>}
     * @memberof RtAircraftPositionQuery
     */
    fromAirports?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof RtAircraftPositionQuery
     */
    toAirports?: Array<string>;
    /**
     * 
     * @type {Array<string>}
     * @memberof RtAircraftPositionQuery
     */
    toOrFromAirports?: Array<string>;
}
/**
 * 
 * @export
 * @interface ScheduledFlightsResponse
 */
export interface ScheduledFlightsResponse {
    /**
     * 
     * @type {number}
     * @memberof ScheduledFlightsResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof ScheduledFlightsResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof ScheduledFlightsResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof ScheduledFlightsResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof ScheduledFlightsResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {Array<ApiFlight>}
     * @memberof ScheduledFlightsResponse
     */
    flights?: Array<ApiFlight>;
}
/**
 * 
 * @export
 * @interface SearchAircraftResponse
 */
export interface SearchAircraftResponse {
    /**
     * 
     * @type {number}
     * @memberof SearchAircraftResponse
     */
    cost?: number;
    /**
     * 
     * @type {boolean}
     * @memberof SearchAircraftResponse
     */
    success?: boolean;
    /**
     * 
     * @type {string}
     * @memberof SearchAircraftResponse
     */
    comment?: string;
    /**
     * 
     * @type {number}
     * @memberof SearchAircraftResponse
     */
    totalRecords?: number;
    /**
     * 
     * @type {number}
     * @memberof SearchAircraftResponse
     */
    maxRecords?: number;
    /**
     * 
     * @type {Array<ApiAircraft>}
     * @memberof SearchAircraftResponse
     */
    aircraft?: Array<ApiAircraft>;
}
/**
 * AircraftApi - fetch parameter creator
 * @export
 */
export const AircraftApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * Use this endpoint if you are looking for details or statistics for a specific aircraft (find by Mode-S hex code or tail number)
         * @summary Aircraft by ID
         * @param {string} [modeS] Mode-S code
         * @param {string} [registration] Registration
         * @param {boolean} [includeStatistics] Include statistics
         * @param {string} [startMonth] Statistics start month (yyyy-MM)
         * @param {string} [endMonth] Statistics end month (yyyy-MM)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAircraft(modeS?: string, registration?: string, includeStatistics?: boolean, startMonth?: string, endMonth?: string, options: any = {}): FetchArgs {
            const localVarPath = `/aircraft`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            if (modeS !== undefined) {
                localVarQueryParameter['modeS'] = modeS;
            }

            if (registration !== undefined) {
                localVarQueryParameter['registration'] = registration;
            }

            if (includeStatistics !== undefined) {
                localVarQueryParameter['includeStatistics'] = includeStatistics;
            }

            if (startMonth !== undefined) {
                localVarQueryParameter['startMonth'] = startMonth;
            }

            if (endMonth !== undefined) {
                localVarQueryParameter['endMonth'] = endMonth;
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Use this endpoint if you want to list all aircraft of a specific ICAO type or company
         * @summary Aircraft search
         * @param {string} [aircraftType] ICAO aircraft type
         * @param {string} [airline] Airline (ICAO code)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAircraft(aircraftType?: string, airline?: string, options: any = {}): FetchArgs {
            const localVarPath = `/aircraft/search`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            if (aircraftType !== undefined) {
                localVarQueryParameter['aircraftType'] = aircraftType;
            }

            if (airline !== undefined) {
                localVarQueryParameter['airline'] = airline;
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * AircraftApi - functional programming interface
 * @export
 */
export const AircraftApiFp = function(configuration?: Configuration) {
    return {
        /**
         * Use this endpoint if you are looking for details or statistics for a specific aircraft (find by Mode-S hex code or tail number)
         * @summary Aircraft by ID
         * @param {string} [modeS] Mode-S code
         * @param {string} [registration] Registration
         * @param {boolean} [includeStatistics] Include statistics
         * @param {string} [startMonth] Statistics start month (yyyy-MM)
         * @param {string} [endMonth] Statistics end month (yyyy-MM)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAircraft(modeS?: string, registration?: string, includeStatistics?: boolean, startMonth?: string, endMonth?: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GetAircraftResponse> {
            const localVarFetchArgs = AircraftApiFetchParamCreator(configuration).getAircraft(modeS, registration, includeStatistics, startMonth, endMonth, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Use this endpoint if you want to list all aircraft of a specific ICAO type or company
         * @summary Aircraft search
         * @param {string} [aircraftType] ICAO aircraft type
         * @param {string} [airline] Airline (ICAO code)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAircraft(aircraftType?: string, airline?: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<SearchAircraftResponse> {
            const localVarFetchArgs = AircraftApiFetchParamCreator(configuration).searchAircraft(aircraftType, airline, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * AircraftApi - factory interface
 * @export
 */
export const AircraftApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * Use this endpoint if you are looking for details or statistics for a specific aircraft (find by Mode-S hex code or tail number)
         * @summary Aircraft by ID
         * @param {string} [modeS] Mode-S code
         * @param {string} [registration] Registration
         * @param {boolean} [includeStatistics] Include statistics
         * @param {string} [startMonth] Statistics start month (yyyy-MM)
         * @param {string} [endMonth] Statistics end month (yyyy-MM)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAircraft(modeS?: string, registration?: string, includeStatistics?: boolean, startMonth?: string, endMonth?: string, options?: any) {
            return AircraftApiFp(configuration).getAircraft(modeS, registration, includeStatistics, startMonth, endMonth, options)(fetch, basePath);
        },
        /**
         * Use this endpoint if you want to list all aircraft of a specific ICAO type or company
         * @summary Aircraft search
         * @param {string} [aircraftType] ICAO aircraft type
         * @param {string} [airline] Airline (ICAO code)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAircraft(aircraftType?: string, airline?: string, options?: any) {
            return AircraftApiFp(configuration).searchAircraft(aircraftType, airline, options)(fetch, basePath);
        },
    };
};

/**
 * AircraftApi - object-oriented interface
 * @export
 * @class AircraftApi
 * @extends {BaseAPI}
 */
export class AircraftApi extends BaseAPI {
    /**
     * Use this endpoint if you are looking for details or statistics for a specific aircraft (find by Mode-S hex code or tail number)
     * @summary Aircraft by ID
     * @param {string} [modeS] Mode-S code
     * @param {string} [registration] Registration
     * @param {boolean} [includeStatistics] Include statistics
     * @param {string} [startMonth] Statistics start month (yyyy-MM)
     * @param {string} [endMonth] Statistics end month (yyyy-MM)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AircraftApi
     */
    public getAircraft(modeS?: string, registration?: string, includeStatistics?: boolean, startMonth?: string, endMonth?: string, options?: any) {
        return AircraftApiFp(this.configuration).getAircraft(modeS, registration, includeStatistics, startMonth, endMonth, options)(this.fetch, this.basePath);
    }

    /**
     * Use this endpoint if you want to list all aircraft of a specific ICAO type or company
     * @summary Aircraft search
     * @param {string} [aircraftType] ICAO aircraft type
     * @param {string} [airline] Airline (ICAO code)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AircraftApi
     */
    public searchAircraft(aircraftType?: string, airline?: string, options?: any) {
        return AircraftApiFp(this.configuration).searchAircraft(aircraftType, airline, options)(this.fetch, this.basePath);
    }

}
/**
 * AirportsApi - fetch parameter creator
 * @export
 */
export const AirportsApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * Use this endpoint if you know exactly which airport you need to know details for - you can search by ICAO or IATA code.
         * @summary Airport by code
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAirport(icaoCode: string, options: any = {}): FetchArgs {
            // verify required parameter 'icaoCode' is not null or undefined
            if (icaoCode === null || icaoCode === undefined) {
                throw new RequiredError('icaoCode','Required parameter icaoCode was null or undefined when calling getAirport.');
            }
            const localVarPath = `/airports/{icaoCode}`
                .replace(`{${"icaoCode"}}`, encodeURIComponent(String(icaoCode)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * ATIS (Automatic Terminal Information Service) is a service that continuously broadcasts aeronautical information around the airport. D-ATIS is the text transcription of the information provided by it. Use this endpoint to find the latest information for a specific airport.
         * @summary Get D-ATIS by airport
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getDatis(icaoCode: string, options: any = {}): FetchArgs {
            // verify required parameter 'icaoCode' is not null or undefined
            if (icaoCode === null || icaoCode === undefined) {
                throw new RequiredError('icaoCode','Required parameter icaoCode was null or undefined when calling getDatis.');
            }
            const localVarPath = `/airports/{icaoCode}/datis`
                .replace(`{${"icaoCode"}}`, encodeURIComponent(String(icaoCode)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * METARs (METeorological Aerodrome Reports) provide a report of the current weather conditions in the vicinity of an aerodrome. Use this endpoint to get the most up-to-date METAR information.
         * @summary Get METAR by airport
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMetar(icaoCode: string, options: any = {}): FetchArgs {
            // verify required parameter 'icaoCode' is not null or undefined
            if (icaoCode === null || icaoCode === undefined) {
                throw new RequiredError('icaoCode','Required parameter icaoCode was null or undefined when calling getMetar.');
            }
            const localVarPath = `/airports/{icaoCode}/metar`
                .replace(`{${"icaoCode"}}`, encodeURIComponent(String(icaoCode)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * TAF (Terminal Aerodrome Forecast) is a weather forecast information service provided by airports to serve the surrounding air traffic. TAF reports are updated several times throughout the day to ensure that pilots have access to the most up-to-date information as possible. You can use this endpoint to get the latest weather information for a specific airport.
         * @summary Get TAF by airport
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getTaf(icaoCode: string, options: any = {}): FetchArgs {
            // verify required parameter 'icaoCode' is not null or undefined
            if (icaoCode === null || icaoCode === undefined) {
                throw new RequiredError('icaoCode','Required parameter icaoCode was null or undefined when calling getTaf.');
            }
            const localVarPath = `/airports/{icaoCode}/taf`
                .replace(`{${"icaoCode"}}`, encodeURIComponent(String(icaoCode)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Use this endpoint if you are trying to find all airports in a country, city or within a specific region.
         * @summary Airport search
         * @param {string} [countryCode] Country code (ISO-2 or ISO-3)
         * @param {string} [countryName] Country name
         * @param {string} [icaoCode] Airport ICAO code
         * @param {boolean} [onlyMajor] Only major airports
         * @param {string} [city] City
         * @param {number} [latitude1] Latitude 1
         * @param {number} [longitude1] Longitude 1
         * @param {number} [latitude2] Latitude 2
         * @param {number} [longitude2] Longitude 2
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAirport(countryCode?: string, countryName?: string, icaoCode?: string, onlyMajor?: boolean, city?: string, latitude1?: number, longitude1?: number, latitude2?: number, longitude2?: number, options: any = {}): FetchArgs {
            const localVarPath = `/airports/search`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            if (countryCode !== undefined) {
                localVarQueryParameter['countryCode'] = countryCode;
            }

            if (countryName !== undefined) {
                localVarQueryParameter['countryName'] = countryName;
            }

            if (icaoCode !== undefined) {
                localVarQueryParameter['icaoCode'] = icaoCode;
            }

            if (onlyMajor !== undefined) {
                localVarQueryParameter['onlyMajor'] = onlyMajor;
            }

            if (city !== undefined) {
                localVarQueryParameter['city'] = city;
            }

            if (latitude1 !== undefined) {
                localVarQueryParameter['latitude1'] = latitude1;
            }

            if (longitude1 !== undefined) {
                localVarQueryParameter['longitude1'] = longitude1;
            }

            if (latitude2 !== undefined) {
                localVarQueryParameter['latitude2'] = latitude2;
            }

            if (longitude2 !== undefined) {
                localVarQueryParameter['longitude2'] = longitude2;
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * AirportsApi - functional programming interface
 * @export
 */
export const AirportsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * Use this endpoint if you know exactly which airport you need to know details for - you can search by ICAO or IATA code.
         * @summary Airport by code
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAirport(icaoCode: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GetAirportResponse> {
            const localVarFetchArgs = AirportsApiFetchParamCreator(configuration).getAirport(icaoCode, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * ATIS (Automatic Terminal Information Service) is a service that continuously broadcasts aeronautical information around the airport. D-ATIS is the text transcription of the information provided by it. Use this endpoint to find the latest information for a specific airport.
         * @summary Get D-ATIS by airport
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getDatis(icaoCode: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GetDatisResponse> {
            const localVarFetchArgs = AirportsApiFetchParamCreator(configuration).getDatis(icaoCode, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * METARs (METeorological Aerodrome Reports) provide a report of the current weather conditions in the vicinity of an aerodrome. Use this endpoint to get the most up-to-date METAR information.
         * @summary Get METAR by airport
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMetar(icaoCode: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GetMetarResponse> {
            const localVarFetchArgs = AirportsApiFetchParamCreator(configuration).getMetar(icaoCode, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * TAF (Terminal Aerodrome Forecast) is a weather forecast information service provided by airports to serve the surrounding air traffic. TAF reports are updated several times throughout the day to ensure that pilots have access to the most up-to-date information as possible. You can use this endpoint to get the latest weather information for a specific airport.
         * @summary Get TAF by airport
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getTaf(icaoCode: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GetTafResponse> {
            const localVarFetchArgs = AirportsApiFetchParamCreator(configuration).getTaf(icaoCode, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Use this endpoint if you are trying to find all airports in a country, city or within a specific region.
         * @summary Airport search
         * @param {string} [countryCode] Country code (ISO-2 or ISO-3)
         * @param {string} [countryName] Country name
         * @param {string} [icaoCode] Airport ICAO code
         * @param {boolean} [onlyMajor] Only major airports
         * @param {string} [city] City
         * @param {number} [latitude1] Latitude 1
         * @param {number} [longitude1] Longitude 1
         * @param {number} [latitude2] Latitude 2
         * @param {number} [longitude2] Longitude 2
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAirport(countryCode?: string, countryName?: string, icaoCode?: string, onlyMajor?: boolean, city?: string, latitude1?: number, longitude1?: number, latitude2?: number, longitude2?: number, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GetAirportsResponse> {
            const localVarFetchArgs = AirportsApiFetchParamCreator(configuration).searchAirport(countryCode, countryName, icaoCode, onlyMajor, city, latitude1, longitude1, latitude2, longitude2, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * AirportsApi - factory interface
 * @export
 */
export const AirportsApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * Use this endpoint if you know exactly which airport you need to know details for - you can search by ICAO or IATA code.
         * @summary Airport by code
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAirport(icaoCode: string, options?: any) {
            return AirportsApiFp(configuration).getAirport(icaoCode, options)(fetch, basePath);
        },
        /**
         * ATIS (Automatic Terminal Information Service) is a service that continuously broadcasts aeronautical information around the airport. D-ATIS is the text transcription of the information provided by it. Use this endpoint to find the latest information for a specific airport.
         * @summary Get D-ATIS by airport
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getDatis(icaoCode: string, options?: any) {
            return AirportsApiFp(configuration).getDatis(icaoCode, options)(fetch, basePath);
        },
        /**
         * METARs (METeorological Aerodrome Reports) provide a report of the current weather conditions in the vicinity of an aerodrome. Use this endpoint to get the most up-to-date METAR information.
         * @summary Get METAR by airport
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMetar(icaoCode: string, options?: any) {
            return AirportsApiFp(configuration).getMetar(icaoCode, options)(fetch, basePath);
        },
        /**
         * TAF (Terminal Aerodrome Forecast) is a weather forecast information service provided by airports to serve the surrounding air traffic. TAF reports are updated several times throughout the day to ensure that pilots have access to the most up-to-date information as possible. You can use this endpoint to get the latest weather information for a specific airport.
         * @summary Get TAF by airport
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getTaf(icaoCode: string, options?: any) {
            return AirportsApiFp(configuration).getTaf(icaoCode, options)(fetch, basePath);
        },
        /**
         * Use this endpoint if you are trying to find all airports in a country, city or within a specific region.
         * @summary Airport search
         * @param {string} [countryCode] Country code (ISO-2 or ISO-3)
         * @param {string} [countryName] Country name
         * @param {string} [icaoCode] Airport ICAO code
         * @param {boolean} [onlyMajor] Only major airports
         * @param {string} [city] City
         * @param {number} [latitude1] Latitude 1
         * @param {number} [longitude1] Longitude 1
         * @param {number} [latitude2] Latitude 2
         * @param {number} [longitude2] Longitude 2
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchAirport(countryCode?: string, countryName?: string, icaoCode?: string, onlyMajor?: boolean, city?: string, latitude1?: number, longitude1?: number, latitude2?: number, longitude2?: number, options?: any) {
            return AirportsApiFp(configuration).searchAirport(countryCode, countryName, icaoCode, onlyMajor, city, latitude1, longitude1, latitude2, longitude2, options)(fetch, basePath);
        },
    };
};

/**
 * AirportsApi - object-oriented interface
 * @export
 * @class AirportsApi
 * @extends {BaseAPI}
 */
export class AirportsApi extends BaseAPI {
    /**
     * Use this endpoint if you know exactly which airport you need to know details for - you can search by ICAO or IATA code.
     * @summary Airport by code
     * @param {string} icaoCode ICAO code
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AirportsApi
     */
    public getAirport(icaoCode: string, options?: any) {
        return AirportsApiFp(this.configuration).getAirport(icaoCode, options)(this.fetch, this.basePath);
    }

    /**
     * ATIS (Automatic Terminal Information Service) is a service that continuously broadcasts aeronautical information around the airport. D-ATIS is the text transcription of the information provided by it. Use this endpoint to find the latest information for a specific airport.
     * @summary Get D-ATIS by airport
     * @param {string} icaoCode ICAO code
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AirportsApi
     */
    public getDatis(icaoCode: string, options?: any) {
        return AirportsApiFp(this.configuration).getDatis(icaoCode, options)(this.fetch, this.basePath);
    }

    /**
     * METARs (METeorological Aerodrome Reports) provide a report of the current weather conditions in the vicinity of an aerodrome. Use this endpoint to get the most up-to-date METAR information.
     * @summary Get METAR by airport
     * @param {string} icaoCode ICAO code
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AirportsApi
     */
    public getMetar(icaoCode: string, options?: any) {
        return AirportsApiFp(this.configuration).getMetar(icaoCode, options)(this.fetch, this.basePath);
    }

    /**
     * TAF (Terminal Aerodrome Forecast) is a weather forecast information service provided by airports to serve the surrounding air traffic. TAF reports are updated several times throughout the day to ensure that pilots have access to the most up-to-date information as possible. You can use this endpoint to get the latest weather information for a specific airport.
     * @summary Get TAF by airport
     * @param {string} icaoCode ICAO code
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AirportsApi
     */
    public getTaf(icaoCode: string, options?: any) {
        return AirportsApiFp(this.configuration).getTaf(icaoCode, options)(this.fetch, this.basePath);
    }

    /**
     * Use this endpoint if you are trying to find all airports in a country, city or within a specific region.
     * @summary Airport search
     * @param {string} [countryCode] Country code (ISO-2 or ISO-3)
     * @param {string} [countryName] Country name
     * @param {string} [icaoCode] Airport ICAO code
     * @param {boolean} [onlyMajor] Only major airports
     * @param {string} [city] City
     * @param {number} [latitude1] Latitude 1
     * @param {number} [longitude1] Longitude 1
     * @param {number} [latitude2] Latitude 2
     * @param {number} [longitude2] Longitude 2
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AirportsApi
     */
    public searchAirport(countryCode?: string, countryName?: string, icaoCode?: string, onlyMajor?: boolean, city?: string, latitude1?: number, longitude1?: number, latitude2?: number, longitude2?: number, options?: any) {
        return AirportsApiFp(this.configuration).searchAirport(countryCode, countryName, icaoCode, onlyMajor, city, latitude1, longitude1, latitude2, longitude2, options)(this.fetch, this.basePath);
    }

}
/**
 * AirspaceApi - fetch parameter creator
 * @export
 */
export const AirspaceApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * The North Atlantic Tracks are high altitude routes across the atlantic between Western Europe and North America. The tracks are updated daily. Use this endpoint to get the most up-to-date tracks
         * @summary NAT (North Atlantic Tracks)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getNatTracks(options: any = {}): FetchArgs {
            const localVarPath = `/airspace/natTracks`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * NOTAMs (NOtice To AirMen) are a way of local aviation authorities alerting pilots of potential hazards. Use this endpoint if you want to see the alerts that are relevant for a specific airport.
         * @summary Get NOTAMS by airport
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getNotams(icaoCode: string, options: any = {}): FetchArgs {
            // verify required parameter 'icaoCode' is not null or undefined
            if (icaoCode === null || icaoCode === undefined) {
                throw new RequiredError('icaoCode','Required parameter icaoCode was null or undefined when calling getNotams.');
            }
            const localVarPath = `/airspace/{icaoCode}/notams`
                .replace(`{${"icaoCode"}}`, encodeURIComponent(String(icaoCode)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Pacific Organized Track System describes the set of routes across the Pacific between Hawaii or North America and Japan/South-east Asia - updated on a daily basis. Use this endpoint to get the most up-to-date information.
         * @summary PAC (Pacific Organized Track System - PACOTS) 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getPacTracks(options: any = {}): FetchArgs {
            const localVarPath = `/airspace/pacTracks`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * AirspaceApi - functional programming interface
 * @export
 */
export const AirspaceApiFp = function(configuration?: Configuration) {
    return {
        /**
         * The North Atlantic Tracks are high altitude routes across the atlantic between Western Europe and North America. The tracks are updated daily. Use this endpoint to get the most up-to-date tracks
         * @summary NAT (North Atlantic Tracks)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getNatTracks(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GetNatPacTracksResponse> {
            const localVarFetchArgs = AirspaceApiFetchParamCreator(configuration).getNatTracks(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * NOTAMs (NOtice To AirMen) are a way of local aviation authorities alerting pilots of potential hazards. Use this endpoint if you want to see the alerts that are relevant for a specific airport.
         * @summary Get NOTAMS by airport
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getNotams(icaoCode: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GetNotamsResponse> {
            const localVarFetchArgs = AirspaceApiFetchParamCreator(configuration).getNotams(icaoCode, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Pacific Organized Track System describes the set of routes across the Pacific between Hawaii or North America and Japan/South-east Asia - updated on a daily basis. Use this endpoint to get the most up-to-date information.
         * @summary PAC (Pacific Organized Track System - PACOTS) 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getPacTracks(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GetNatPacTracksResponse> {
            const localVarFetchArgs = AirspaceApiFetchParamCreator(configuration).getPacTracks(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * AirspaceApi - factory interface
 * @export
 */
export const AirspaceApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * The North Atlantic Tracks are high altitude routes across the atlantic between Western Europe and North America. The tracks are updated daily. Use this endpoint to get the most up-to-date tracks
         * @summary NAT (North Atlantic Tracks)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getNatTracks(options?: any) {
            return AirspaceApiFp(configuration).getNatTracks(options)(fetch, basePath);
        },
        /**
         * NOTAMs (NOtice To AirMen) are a way of local aviation authorities alerting pilots of potential hazards. Use this endpoint if you want to see the alerts that are relevant for a specific airport.
         * @summary Get NOTAMS by airport
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getNotams(icaoCode: string, options?: any) {
            return AirspaceApiFp(configuration).getNotams(icaoCode, options)(fetch, basePath);
        },
        /**
         * Pacific Organized Track System describes the set of routes across the Pacific between Hawaii or North America and Japan/South-east Asia - updated on a daily basis. Use this endpoint to get the most up-to-date information.
         * @summary PAC (Pacific Organized Track System - PACOTS) 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getPacTracks(options?: any) {
            return AirspaceApiFp(configuration).getPacTracks(options)(fetch, basePath);
        },
    };
};

/**
 * AirspaceApi - object-oriented interface
 * @export
 * @class AirspaceApi
 * @extends {BaseAPI}
 */
export class AirspaceApi extends BaseAPI {
    /**
     * The North Atlantic Tracks are high altitude routes across the atlantic between Western Europe and North America. The tracks are updated daily. Use this endpoint to get the most up-to-date tracks
     * @summary NAT (North Atlantic Tracks)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AirspaceApi
     */
    public getNatTracks(options?: any) {
        return AirspaceApiFp(this.configuration).getNatTracks(options)(this.fetch, this.basePath);
    }

    /**
     * NOTAMs (NOtice To AirMen) are a way of local aviation authorities alerting pilots of potential hazards. Use this endpoint if you want to see the alerts that are relevant for a specific airport.
     * @summary Get NOTAMS by airport
     * @param {string} icaoCode ICAO code
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AirspaceApi
     */
    public getNotams(icaoCode: string, options?: any) {
        return AirspaceApiFp(this.configuration).getNotams(icaoCode, options)(this.fetch, this.basePath);
    }

    /**
     * Pacific Organized Track System describes the set of routes across the Pacific between Hawaii or North America and Japan/South-east Asia - updated on a daily basis. Use this endpoint to get the most up-to-date information.
     * @summary PAC (Pacific Organized Track System - PACOTS) 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AirspaceApi
     */
    public getPacTracks(options?: any) {
        return AirspaceApiFp(this.configuration).getPacTracks(options)(this.fetch, this.basePath);
    }

}
/**
 * BillingApi - fetch parameter creator
 * @export
 */
export const BillingApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * Use this endpoint if you woould like to view details on the current usage of credit in your account
         * @summary Get the current billing status
         * @param {string} [authorization] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        status(authorization?: string, options: any = {}): FetchArgs {
            const localVarPath = `/billing/status`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            if (authorization !== undefined && authorization !== null) {
                localVarHeaderParameter['Authorization'] = String(authorization);
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Use this endpoint if you would like to view the latest usage of your token
         * @summary Get the latest token usage statistics
         * @param {string} [authorization] 
         * @param {Date} [fromDate] Show usage from this date only
         * @param {Date} [toDate] Show usage to this date only
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        usage(authorization?: string, fromDate?: Date, toDate?: Date, options: any = {}): FetchArgs {
            const localVarPath = `/billing/usage`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            if (fromDate !== undefined) {
                localVarQueryParameter['fromDate'] = (fromDate as any).toISOString();
            }

            if (toDate !== undefined) {
                localVarQueryParameter['toDate'] = (toDate as any).toISOString();
            }

            if (authorization !== undefined && authorization !== null) {
                localVarHeaderParameter['Authorization'] = String(authorization);
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * BillingApi - functional programming interface
 * @export
 */
export const BillingApiFp = function(configuration?: Configuration) {
    return {
        /**
         * Use this endpoint if you woould like to view details on the current usage of credit in your account
         * @summary Get the current billing status
         * @param {string} [authorization] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        status(authorization?: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<BillingStatusResponse> {
            const localVarFetchArgs = BillingApiFetchParamCreator(configuration).status(authorization, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Use this endpoint if you would like to view the latest usage of your token
         * @summary Get the latest token usage statistics
         * @param {string} [authorization] 
         * @param {Date} [fromDate] Show usage from this date only
         * @param {Date} [toDate] Show usage to this date only
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        usage(authorization?: string, fromDate?: Date, toDate?: Date, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<BillingUsageResponse> {
            const localVarFetchArgs = BillingApiFetchParamCreator(configuration).usage(authorization, fromDate, toDate, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * BillingApi - factory interface
 * @export
 */
export const BillingApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * Use this endpoint if you woould like to view details on the current usage of credit in your account
         * @summary Get the current billing status
         * @param {string} [authorization] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        status(authorization?: string, options?: any) {
            return BillingApiFp(configuration).status(authorization, options)(fetch, basePath);
        },
        /**
         * Use this endpoint if you would like to view the latest usage of your token
         * @summary Get the latest token usage statistics
         * @param {string} [authorization] 
         * @param {Date} [fromDate] Show usage from this date only
         * @param {Date} [toDate] Show usage to this date only
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        usage(authorization?: string, fromDate?: Date, toDate?: Date, options?: any) {
            return BillingApiFp(configuration).usage(authorization, fromDate, toDate, options)(fetch, basePath);
        },
    };
};

/**
 * BillingApi - object-oriented interface
 * @export
 * @class BillingApi
 * @extends {BaseAPI}
 */
export class BillingApi extends BaseAPI {
    /**
     * Use this endpoint if you woould like to view details on the current usage of credit in your account
     * @summary Get the current billing status
     * @param {string} [authorization] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof BillingApi
     */
    public status(authorization?: string, options?: any) {
        return BillingApiFp(this.configuration).status(authorization, options)(this.fetch, this.basePath);
    }

    /**
     * Use this endpoint if you would like to view the latest usage of your token
     * @summary Get the latest token usage statistics
     * @param {string} [authorization] 
     * @param {Date} [fromDate] Show usage from this date only
     * @param {Date} [toDate] Show usage to this date only
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof BillingApi
     */
    public usage(authorization?: string, fromDate?: Date, toDate?: Date, options?: any) {
        return BillingApiFp(this.configuration).usage(authorization, fromDate, toDate, options)(this.fetch, this.basePath);
    }

}
/**
 * FlightsApi - fetch parameter creator
 * @export
 */
export const FlightsApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * Use this endpoint if your goal is to get real time information for live flights, either if you are looking for a specific geographical location or particular aircraft/airline/airport.
         * @summary Get live flights 
         * @param {RtAircraftPositionQuery} [body] 
         * @param {string} [authorization] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        aircraftPosition(body?: RtAircraftPositionQuery, authorization?: string, options: any = {}): FetchArgs {
            const localVarPath = `/flights/live`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            if (authorization !== undefined && authorization !== null) {
                localVarHeaderParameter['Authorization'] = String(authorization);
            }

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            const needsSerialization = (<any>"RtAircraftPositionQuery" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(body || {}) : (body || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Use this endpoint if you are interested in knowing which flights have flown over a particular geographical area at a given point in time
         * @summary Search flights by geographical area
         * @param {GeoSearchQuery} [body] 
         * @param {string} [authorization] 
         * @param {number} [page] Request page
         * @param {number} [pageSize] Page size
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geosearch(body?: GeoSearchQuery, authorization?: string, page?: number, pageSize?: number, options: any = {}): FetchArgs {
            const localVarPath = `/flights/geosearch`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['pageSize'] = pageSize;
            }

            if (authorization !== undefined && authorization !== null) {
                localVarHeaderParameter['Authorization'] = String(authorization);
            }

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            const needsSerialization = (<any>"GeoSearchQuery" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(body || {}) : (body || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Use this endpoint if you want to know schedules of future flights
         * @summary Get scheduled flights
         * @param {string} [authorization] 
         * @param {string} [flightId] Flight ID/Number (IATA) - partial entries can be used (e.g. AA3*)
         * @param {string} [fromAirport] Request only flights departing from this airport (IATA/ICAO)
         * @param {string} [toAirport] Request only flights arriving to this airport (IATA/ICAO)
         * @param {string} [airline] Request only flights for this airline
         * @param {Date} [departureFromDate] Request only flights that depart from this date onwards (format yyyy-MM-dd&#x27;T&#x27;HH:mm:ss&#x27;Z&#x27;)
         * @param {Date} [departureToDate] Request only flights that depart until this date (format yyyy-MM-dd&#x27;T&#x27;HH:mm:ss&#x27;Z&#x27;)
         * @param {Date} [arrivalFromDate] Request only flights that arrive from this date onwards (format yyyy-MM-dd&#x27;T&#x27;HH:mm:ss&#x27;Z&#x27;)
         * @param {Date} [arrivalToDate] Request only flights that arrive until this date (format yyyy-MM-dd&#x27;T&#x27;HH:mm:ss&#x27;Z&#x27;)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getScheduledFlights(authorization?: string, flightId?: string, fromAirport?: string, toAirport?: string, airline?: string, departureFromDate?: Date, departureToDate?: Date, arrivalFromDate?: Date, arrivalToDate?: Date, options: any = {}): FetchArgs {
            const localVarPath = `/flights/schedules`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            if (flightId !== undefined) {
                localVarQueryParameter['flightId'] = flightId;
            }

            if (fromAirport !== undefined) {
                localVarQueryParameter['fromAirport'] = fromAirport;
            }

            if (toAirport !== undefined) {
                localVarQueryParameter['toAirport'] = toAirport;
            }

            if (airline !== undefined) {
                localVarQueryParameter['airline'] = airline;
            }

            if (departureFromDate !== undefined) {
                localVarQueryParameter['departureFromDate'] = (departureFromDate as any).toISOString();
            }

            if (departureToDate !== undefined) {
                localVarQueryParameter['departureToDate'] = (departureToDate as any).toISOString();
            }

            if (arrivalFromDate !== undefined) {
                localVarQueryParameter['arrivalFromDate'] = (arrivalFromDate as any).toISOString();
            }

            if (arrivalToDate !== undefined) {
                localVarQueryParameter['arrivalToDate'] = (arrivalToDate as any).toISOString();
            }

            if (authorization !== undefined && authorization !== null) {
                localVarHeaderParameter['Authorization'] = String(authorization);
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Use this endpoint for general flight searches - past, present or future (scheduled) - based on departure/arrival location or individual flights and tail numbers. The search always needs to be restricted by date (either departure, arrival or both).
         * @summary Search flights
         * @param {FlightsQuery} [body] 
         * @param {string} [authorization] 
         * @param {number} [page] Request page
         * @param {number} [pageSize] Page size
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        search(body?: FlightsQuery, authorization?: string, page?: number, pageSize?: number, options: any = {}): FetchArgs {
            const localVarPath = `/flights/search`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['pageSize'] = pageSize;
            }

            if (authorization !== undefined && authorization !== null) {
                localVarHeaderParameter['Authorization'] = String(authorization);
            }

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            const needsSerialization = (<any>"FlightsQuery" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(body || {}) : (body || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * FlightsApi - functional programming interface
 * @export
 */
export const FlightsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * Use this endpoint if your goal is to get real time information for live flights, either if you are looking for a specific geographical location or particular aircraft/airline/airport.
         * @summary Get live flights 
         * @param {RtAircraftPositionQuery} [body] 
         * @param {string} [authorization] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        aircraftPosition(body?: RtAircraftPositionQuery, authorization?: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<FlightsResponse> {
            const localVarFetchArgs = FlightsApiFetchParamCreator(configuration).aircraftPosition(body, authorization, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Use this endpoint if you are interested in knowing which flights have flown over a particular geographical area at a given point in time
         * @summary Search flights by geographical area
         * @param {GeoSearchQuery} [body] 
         * @param {string} [authorization] 
         * @param {number} [page] Request page
         * @param {number} [pageSize] Page size
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geosearch(body?: GeoSearchQuery, authorization?: string, page?: number, pageSize?: number, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<FlightsResponse> {
            const localVarFetchArgs = FlightsApiFetchParamCreator(configuration).geosearch(body, authorization, page, pageSize, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Use this endpoint if you want to know schedules of future flights
         * @summary Get scheduled flights
         * @param {string} [authorization] 
         * @param {string} [flightId] Flight ID/Number (IATA) - partial entries can be used (e.g. AA3*)
         * @param {string} [fromAirport] Request only flights departing from this airport (IATA/ICAO)
         * @param {string} [toAirport] Request only flights arriving to this airport (IATA/ICAO)
         * @param {string} [airline] Request only flights for this airline
         * @param {Date} [departureFromDate] Request only flights that depart from this date onwards (format yyyy-MM-dd&#x27;T&#x27;HH:mm:ss&#x27;Z&#x27;)
         * @param {Date} [departureToDate] Request only flights that depart until this date (format yyyy-MM-dd&#x27;T&#x27;HH:mm:ss&#x27;Z&#x27;)
         * @param {Date} [arrivalFromDate] Request only flights that arrive from this date onwards (format yyyy-MM-dd&#x27;T&#x27;HH:mm:ss&#x27;Z&#x27;)
         * @param {Date} [arrivalToDate] Request only flights that arrive until this date (format yyyy-MM-dd&#x27;T&#x27;HH:mm:ss&#x27;Z&#x27;)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getScheduledFlights(authorization?: string, flightId?: string, fromAirport?: string, toAirport?: string, airline?: string, departureFromDate?: Date, departureToDate?: Date, arrivalFromDate?: Date, arrivalToDate?: Date, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<ScheduledFlightsResponse> {
            const localVarFetchArgs = FlightsApiFetchParamCreator(configuration).getScheduledFlights(authorization, flightId, fromAirport, toAirport, airline, departureFromDate, departureToDate, arrivalFromDate, arrivalToDate, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Use this endpoint for general flight searches - past, present or future (scheduled) - based on departure/arrival location or individual flights and tail numbers. The search always needs to be restricted by date (either departure, arrival or both).
         * @summary Search flights
         * @param {FlightsQuery} [body] 
         * @param {string} [authorization] 
         * @param {number} [page] Request page
         * @param {number} [pageSize] Page size
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        search(body?: FlightsQuery, authorization?: string, page?: number, pageSize?: number, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<FlightsResponse> {
            const localVarFetchArgs = FlightsApiFetchParamCreator(configuration).search(body, authorization, page, pageSize, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * FlightsApi - factory interface
 * @export
 */
export const FlightsApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * Use this endpoint if your goal is to get real time information for live flights, either if you are looking for a specific geographical location or particular aircraft/airline/airport.
         * @summary Get live flights 
         * @param {RtAircraftPositionQuery} [body] 
         * @param {string} [authorization] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        aircraftPosition(body?: RtAircraftPositionQuery, authorization?: string, options?: any) {
            return FlightsApiFp(configuration).aircraftPosition(body, authorization, options)(fetch, basePath);
        },
        /**
         * Use this endpoint if you are interested in knowing which flights have flown over a particular geographical area at a given point in time
         * @summary Search flights by geographical area
         * @param {GeoSearchQuery} [body] 
         * @param {string} [authorization] 
         * @param {number} [page] Request page
         * @param {number} [pageSize] Page size
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geosearch(body?: GeoSearchQuery, authorization?: string, page?: number, pageSize?: number, options?: any) {
            return FlightsApiFp(configuration).geosearch(body, authorization, page, pageSize, options)(fetch, basePath);
        },
        /**
         * Use this endpoint if you want to know schedules of future flights
         * @summary Get scheduled flights
         * @param {string} [authorization] 
         * @param {string} [flightId] Flight ID/Number (IATA) - partial entries can be used (e.g. AA3*)
         * @param {string} [fromAirport] Request only flights departing from this airport (IATA/ICAO)
         * @param {string} [toAirport] Request only flights arriving to this airport (IATA/ICAO)
         * @param {string} [airline] Request only flights for this airline
         * @param {Date} [departureFromDate] Request only flights that depart from this date onwards (format yyyy-MM-dd&#x27;T&#x27;HH:mm:ss&#x27;Z&#x27;)
         * @param {Date} [departureToDate] Request only flights that depart until this date (format yyyy-MM-dd&#x27;T&#x27;HH:mm:ss&#x27;Z&#x27;)
         * @param {Date} [arrivalFromDate] Request only flights that arrive from this date onwards (format yyyy-MM-dd&#x27;T&#x27;HH:mm:ss&#x27;Z&#x27;)
         * @param {Date} [arrivalToDate] Request only flights that arrive until this date (format yyyy-MM-dd&#x27;T&#x27;HH:mm:ss&#x27;Z&#x27;)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getScheduledFlights(authorization?: string, flightId?: string, fromAirport?: string, toAirport?: string, airline?: string, departureFromDate?: Date, departureToDate?: Date, arrivalFromDate?: Date, arrivalToDate?: Date, options?: any) {
            return FlightsApiFp(configuration).getScheduledFlights(authorization, flightId, fromAirport, toAirport, airline, departureFromDate, departureToDate, arrivalFromDate, arrivalToDate, options)(fetch, basePath);
        },
        /**
         * Use this endpoint for general flight searches - past, present or future (scheduled) - based on departure/arrival location or individual flights and tail numbers. The search always needs to be restricted by date (either departure, arrival or both).
         * @summary Search flights
         * @param {FlightsQuery} [body] 
         * @param {string} [authorization] 
         * @param {number} [page] Request page
         * @param {number} [pageSize] Page size
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        search(body?: FlightsQuery, authorization?: string, page?: number, pageSize?: number, options?: any) {
            return FlightsApiFp(configuration).search(body, authorization, page, pageSize, options)(fetch, basePath);
        },
    };
};

/**
 * FlightsApi - object-oriented interface
 * @export
 * @class FlightsApi
 * @extends {BaseAPI}
 */
export class FlightsApi extends BaseAPI {
    /**
     * Use this endpoint if your goal is to get real time information for live flights, either if you are looking for a specific geographical location or particular aircraft/airline/airport.
     * @summary Get live flights 
     * @param {RtAircraftPositionQuery} [body] 
     * @param {string} [authorization] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FlightsApi
     */
    public aircraftPosition(body?: RtAircraftPositionQuery, authorization?: string, options?: any) {
        return FlightsApiFp(this.configuration).aircraftPosition(body, authorization, options)(this.fetch, this.basePath);
    }

    /**
     * Use this endpoint if you are interested in knowing which flights have flown over a particular geographical area at a given point in time
     * @summary Search flights by geographical area
     * @param {GeoSearchQuery} [body] 
     * @param {string} [authorization] 
     * @param {number} [page] Request page
     * @param {number} [pageSize] Page size
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FlightsApi
     */
    public geosearch(body?: GeoSearchQuery, authorization?: string, page?: number, pageSize?: number, options?: any) {
        return FlightsApiFp(this.configuration).geosearch(body, authorization, page, pageSize, options)(this.fetch, this.basePath);
    }

    /**
     * Use this endpoint if you want to know schedules of future flights
     * @summary Get scheduled flights
     * @param {string} [authorization] 
     * @param {string} [flightId] Flight ID/Number (IATA) - partial entries can be used (e.g. AA3*)
     * @param {string} [fromAirport] Request only flights departing from this airport (IATA/ICAO)
     * @param {string} [toAirport] Request only flights arriving to this airport (IATA/ICAO)
     * @param {string} [airline] Request only flights for this airline
     * @param {Date} [departureFromDate] Request only flights that depart from this date onwards (format yyyy-MM-dd&#x27;T&#x27;HH:mm:ss&#x27;Z&#x27;)
     * @param {Date} [departureToDate] Request only flights that depart until this date (format yyyy-MM-dd&#x27;T&#x27;HH:mm:ss&#x27;Z&#x27;)
     * @param {Date} [arrivalFromDate] Request only flights that arrive from this date onwards (format yyyy-MM-dd&#x27;T&#x27;HH:mm:ss&#x27;Z&#x27;)
     * @param {Date} [arrivalToDate] Request only flights that arrive until this date (format yyyy-MM-dd&#x27;T&#x27;HH:mm:ss&#x27;Z&#x27;)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FlightsApi
     */
    public getScheduledFlights(authorization?: string, flightId?: string, fromAirport?: string, toAirport?: string, airline?: string, departureFromDate?: Date, departureToDate?: Date, arrivalFromDate?: Date, arrivalToDate?: Date, options?: any) {
        return FlightsApiFp(this.configuration).getScheduledFlights(authorization, flightId, fromAirport, toAirport, airline, departureFromDate, departureToDate, arrivalFromDate, arrivalToDate, options)(this.fetch, this.basePath);
    }

    /**
     * Use this endpoint for general flight searches - past, present or future (scheduled) - based on departure/arrival location or individual flights and tail numbers. The search always needs to be restricted by date (either departure, arrival or both).
     * @summary Search flights
     * @param {FlightsQuery} [body] 
     * @param {string} [authorization] 
     * @param {number} [page] Request page
     * @param {number} [pageSize] Page size
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FlightsApi
     */
    public search(body?: FlightsQuery, authorization?: string, page?: number, pageSize?: number, options?: any) {
        return FlightsApiFp(this.configuration).search(body, authorization, page, pageSize, options)(this.fetch, this.basePath);
    }

}
/**
 * StatisticsApi - fetch parameter creator
 * @export
 */
export const StatisticsApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * Get detailed statistics for a specific airline
         * @summary Statistics for a specific airline
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAirlineStatistics(icaoCode: string, options: any = {}): FetchArgs {
            // verify required parameter 'icaoCode' is not null or undefined
            if (icaoCode === null || icaoCode === undefined) {
                throw new RequiredError('icaoCode','Required parameter icaoCode was null or undefined when calling getAirlineStatistics.');
            }
            const localVarPath = `/statistics/airline/{icaoCode}`
                .replace(`{${"icaoCode"}}`, encodeURIComponent(String(icaoCode)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Get statistics for major airlines
         * @summary Statistics for major airlines
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAirlinesStatistics(options: any = {}): FetchArgs {
            const localVarPath = `/statistics/airlines`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Get statistics for business jet models
         * @summary Statistics for business jet models
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getBusJetModelsStatisticsInternal(options: any = {}): FetchArgs {
            const localVarPath = `/statistics/flights/business/models`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Get statistics for business jet operators
         * @summary Statistics for business jet operators
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getBusJetOperatorStatisticsInternal(options: any = {}): FetchArgs {
            const localVarPath = `/statistics/flights/business/operators`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Get statistics for business flights on major airports
         * @summary Statistics for business flights on major airports
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getBusinessAirportStatistics(options: any = {}): FetchArgs {
            const localVarPath = `/statistics/airports/business`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Get statistics for all business flights
         * @summary Flights statistics (business)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getBusinessFlightsStatistics(options: any = {}): FetchArgs {
            const localVarPath = `/statistics/flights/business`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Get statistics for commercial flights on major airports
         * @summary Statistics for commercial flights on major airports
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCommercialAirportStatistics(options: any = {}): FetchArgs {
            const localVarPath = `/statistics/airports/commercial`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Get statistics for all commercial flights
         * @summary Flights statistics (commercial)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCommercialFlightsStatistics(options: any = {}): FetchArgs {
            const localVarPath = `/statistics/flights/commercial`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Get statistics for all flights worldwide
         * @summary Statistics for all flights
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getFlightsStatistics(options: any = {}): FetchArgs {
            const localVarPath = `/statistics/flights`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Get statistics for a specific airport
         * @summary Statistics for major airports
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMajorAirportStatistics(options: any = {}): FetchArgs {
            const localVarPath = `/statistics/airports`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerToken required

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * StatisticsApi - functional programming interface
 * @export
 */
export const StatisticsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * Get detailed statistics for a specific airline
         * @summary Statistics for a specific airline
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAirlineStatistics(icaoCode: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<AirlineStatisticsResponse> {
            const localVarFetchArgs = StatisticsApiFetchParamCreator(configuration).getAirlineStatistics(icaoCode, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Get statistics for major airlines
         * @summary Statistics for major airlines
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAirlinesStatistics(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<AirlineStatisticsResponse> {
            const localVarFetchArgs = StatisticsApiFetchParamCreator(configuration).getAirlinesStatistics(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Get statistics for business jet models
         * @summary Statistics for business jet models
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getBusJetModelsStatisticsInternal(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<BusinessJetModelStatisticsResponse> {
            const localVarFetchArgs = StatisticsApiFetchParamCreator(configuration).getBusJetModelsStatisticsInternal(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Get statistics for business jet operators
         * @summary Statistics for business jet operators
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getBusJetOperatorStatisticsInternal(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<BusinessJetOperatorStatisticsResponse> {
            const localVarFetchArgs = StatisticsApiFetchParamCreator(configuration).getBusJetOperatorStatisticsInternal(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Get statistics for business flights on major airports
         * @summary Statistics for business flights on major airports
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getBusinessAirportStatistics(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<AirportsStatisticsResponse> {
            const localVarFetchArgs = StatisticsApiFetchParamCreator(configuration).getBusinessAirportStatistics(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Get statistics for all business flights
         * @summary Flights statistics (business)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getBusinessFlightsStatistics(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<FlightsStatisticsResponse> {
            const localVarFetchArgs = StatisticsApiFetchParamCreator(configuration).getBusinessFlightsStatistics(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Get statistics for commercial flights on major airports
         * @summary Statistics for commercial flights on major airports
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCommercialAirportStatistics(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<AirportsStatisticsResponse> {
            const localVarFetchArgs = StatisticsApiFetchParamCreator(configuration).getCommercialAirportStatistics(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Get statistics for all commercial flights
         * @summary Flights statistics (commercial)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCommercialFlightsStatistics(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<FlightsStatisticsResponse> {
            const localVarFetchArgs = StatisticsApiFetchParamCreator(configuration).getCommercialFlightsStatistics(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Get statistics for all flights worldwide
         * @summary Statistics for all flights
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getFlightsStatistics(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<FlightsStatisticsResponse> {
            const localVarFetchArgs = StatisticsApiFetchParamCreator(configuration).getFlightsStatistics(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Get statistics for a specific airport
         * @summary Statistics for major airports
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMajorAirportStatistics(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<AirportsStatisticsResponse> {
            const localVarFetchArgs = StatisticsApiFetchParamCreator(configuration).getMajorAirportStatistics(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * StatisticsApi - factory interface
 * @export
 */
export const StatisticsApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * Get detailed statistics for a specific airline
         * @summary Statistics for a specific airline
         * @param {string} icaoCode ICAO code
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAirlineStatistics(icaoCode: string, options?: any) {
            return StatisticsApiFp(configuration).getAirlineStatistics(icaoCode, options)(fetch, basePath);
        },
        /**
         * Get statistics for major airlines
         * @summary Statistics for major airlines
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAirlinesStatistics(options?: any) {
            return StatisticsApiFp(configuration).getAirlinesStatistics(options)(fetch, basePath);
        },
        /**
         * Get statistics for business jet models
         * @summary Statistics for business jet models
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getBusJetModelsStatisticsInternal(options?: any) {
            return StatisticsApiFp(configuration).getBusJetModelsStatisticsInternal(options)(fetch, basePath);
        },
        /**
         * Get statistics for business jet operators
         * @summary Statistics for business jet operators
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getBusJetOperatorStatisticsInternal(options?: any) {
            return StatisticsApiFp(configuration).getBusJetOperatorStatisticsInternal(options)(fetch, basePath);
        },
        /**
         * Get statistics for business flights on major airports
         * @summary Statistics for business flights on major airports
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getBusinessAirportStatistics(options?: any) {
            return StatisticsApiFp(configuration).getBusinessAirportStatistics(options)(fetch, basePath);
        },
        /**
         * Get statistics for all business flights
         * @summary Flights statistics (business)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getBusinessFlightsStatistics(options?: any) {
            return StatisticsApiFp(configuration).getBusinessFlightsStatistics(options)(fetch, basePath);
        },
        /**
         * Get statistics for commercial flights on major airports
         * @summary Statistics for commercial flights on major airports
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCommercialAirportStatistics(options?: any) {
            return StatisticsApiFp(configuration).getCommercialAirportStatistics(options)(fetch, basePath);
        },
        /**
         * Get statistics for all commercial flights
         * @summary Flights statistics (commercial)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCommercialFlightsStatistics(options?: any) {
            return StatisticsApiFp(configuration).getCommercialFlightsStatistics(options)(fetch, basePath);
        },
        /**
         * Get statistics for all flights worldwide
         * @summary Statistics for all flights
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getFlightsStatistics(options?: any) {
            return StatisticsApiFp(configuration).getFlightsStatistics(options)(fetch, basePath);
        },
        /**
         * Get statistics for a specific airport
         * @summary Statistics for major airports
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMajorAirportStatistics(options?: any) {
            return StatisticsApiFp(configuration).getMajorAirportStatistics(options)(fetch, basePath);
        },
    };
};

/**
 * StatisticsApi - object-oriented interface
 * @export
 * @class StatisticsApi
 * @extends {BaseAPI}
 */
export class StatisticsApi extends BaseAPI {
    /**
     * Get detailed statistics for a specific airline
     * @summary Statistics for a specific airline
     * @param {string} icaoCode ICAO code
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StatisticsApi
     */
    public getAirlineStatistics(icaoCode: string, options?: any) {
        return StatisticsApiFp(this.configuration).getAirlineStatistics(icaoCode, options)(this.fetch, this.basePath);
    }

    /**
     * Get statistics for major airlines
     * @summary Statistics for major airlines
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StatisticsApi
     */
    public getAirlinesStatistics(options?: any) {
        return StatisticsApiFp(this.configuration).getAirlinesStatistics(options)(this.fetch, this.basePath);
    }

    /**
     * Get statistics for business jet models
     * @summary Statistics for business jet models
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StatisticsApi
     */
    public getBusJetModelsStatisticsInternal(options?: any) {
        return StatisticsApiFp(this.configuration).getBusJetModelsStatisticsInternal(options)(this.fetch, this.basePath);
    }

    /**
     * Get statistics for business jet operators
     * @summary Statistics for business jet operators
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StatisticsApi
     */
    public getBusJetOperatorStatisticsInternal(options?: any) {
        return StatisticsApiFp(this.configuration).getBusJetOperatorStatisticsInternal(options)(this.fetch, this.basePath);
    }

    /**
     * Get statistics for business flights on major airports
     * @summary Statistics for business flights on major airports
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StatisticsApi
     */
    public getBusinessAirportStatistics(options?: any) {
        return StatisticsApiFp(this.configuration).getBusinessAirportStatistics(options)(this.fetch, this.basePath);
    }

    /**
     * Get statistics for all business flights
     * @summary Flights statistics (business)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StatisticsApi
     */
    public getBusinessFlightsStatistics(options?: any) {
        return StatisticsApiFp(this.configuration).getBusinessFlightsStatistics(options)(this.fetch, this.basePath);
    }

    /**
     * Get statistics for commercial flights on major airports
     * @summary Statistics for commercial flights on major airports
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StatisticsApi
     */
    public getCommercialAirportStatistics(options?: any) {
        return StatisticsApiFp(this.configuration).getCommercialAirportStatistics(options)(this.fetch, this.basePath);
    }

    /**
     * Get statistics for all commercial flights
     * @summary Flights statistics (commercial)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StatisticsApi
     */
    public getCommercialFlightsStatistics(options?: any) {
        return StatisticsApiFp(this.configuration).getCommercialFlightsStatistics(options)(this.fetch, this.basePath);
    }

    /**
     * Get statistics for all flights worldwide
     * @summary Statistics for all flights
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StatisticsApi
     */
    public getFlightsStatistics(options?: any) {
        return StatisticsApiFp(this.configuration).getFlightsStatistics(options)(this.fetch, this.basePath);
    }

    /**
     * Get statistics for a specific airport
     * @summary Statistics for major airports
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StatisticsApi
     */
    public getMajorAirportStatistics(options?: any) {
        return StatisticsApiFp(this.configuration).getMajorAirportStatistics(options)(this.fetch, this.basePath);
    }

}
